ScriptName srPerkManipMenu Extends SKI_ConfigBase

;Version Eaxample: 10201 is v1.02.01
Int Function GetVersion()
	Return 20013
EndFunction

;version of JContainers being utilized
Int JC_API_Version = 3

Actor Property PlayerRef Auto ;CK will auto-fill the player reference

Race PlayerRace

;Race vars for comparing against
String Altmer = "[Race <HighElfRace (00013743)>]"
String Argonian = "[Race <ArgonianRace (00013740)>]"
String Bosmer = "[Race <WoodElfRace (00013749)>]"
String Breton = "[Race <BretonRace (00013741)>]"
String Dunmer = "[Race <DarkElfRace (00013742)>]"
String Imperial = "[Race <ImperialRace (00013744)>]"
String Khajiit = "[Race <KhajiitRace (00013745)>]"
String Nord = "[Race <NordRace (00013746)>]"
String Orc = "[Race <Orcrace (00013747)>]"
String Redguard = "[Race <RedguardRace (00013748)>]"

;Categorized perk lists
Perk[] Property AlchemyPerks Auto
Perk[] Property AlterationPerks Auto
Perk[] Property ArcheryPerks Auto
Perk[] Property BlockPerks Auto
Perk[] Property ConjurationPerks Auto
Perk[] Property DestructionPerks Auto
Perk[] Property EnchantingPerks Auto
Perk[] Property HeavyArmorPerks Auto
Perk[] Property IllusionPerks Auto
Perk[] Property LightArmorPerks Auto
Perk[] Property LockpickingPerks Auto
Perk[] Property OneHandedPerks Auto
Perk[] Property PickpocketPerks Auto
Perk[] Property RestorationPerks Auto
Perk[] Property SmithingPerks Auto
Perk[] Property SneakPerks Auto
Perk[] Property SpeechPerks Auto
Perk[] Property TwoHandedPerks Auto

;Perk toggle OIDs
Int[] AlchemyPerksID
Int[] AlterationPerksID
Int[] ArcheryPerksID
Int[] BlockPerksID
Int[] ConjurationPerksID
Int[] DestructionPerksID
Int[] EnchantingPerksID
Int[] HeavyArmorPerksID
Int[] IllusionPerksID
Int[] LightArmorPerksID
Int[] LockpickingPerksID
Int[] OneHandedPerksID
Int[] PickpocketPerksID
Int[] RestorationPerksID
Int[] SmithingPerksID
Int[] SneakPerksID
Int[] SpeechPerksID
Int[] TwoHandedPerksID

;Perk toggle states
Bool[] AlchemyPerksState
Bool[] AlterationPerksState
Bool[] ArcheryPerksState
Bool[] BlockPerksState
Bool[] ConjurationPerksState
Bool[] DestructionPerksState
Bool[] EnchantingPerksState
Bool[] HeavyArmorPerksState
Bool[] IllusionPerksState
Bool[] LightArmorPerksState
Bool[] LockpickingPerksState
Bool[] OneHandedPerksState
Bool[] PickpocketPerksState
Bool[] RestorationPerksState
Bool[] SmithingPerksState
Bool[] SneakPerksState
Bool[] SpeechPerksState
Bool[] TwoHandedPerksState

;Perk tracker arrays
Bool[] AlchemyPerksTrack
Bool[] AlterationPerksTrack
Bool[] ArcheryPerksTrack
Bool[] BlockPerksTrack
Bool[] ConjurationPerksTrack
Bool[] DestructionPerksTrack
Bool[] EnchantingPerksTrack
Bool[] HeavyArmorPerksTrack
Bool[] IllusionPerksTrack
Bool[] LightArmorPerksTrack
Bool[] LockpickingPerksTrack
Bool[] OneHandedPerksTrack
Bool[] PickpocketPerksTrack
Bool[] RestorationPerksTrack
Bool[] SmithingPerksTrack
Bool[] SneakPerksTrack
Bool[] SpeechPerksTrack
Bool[] TwoHandedPerksTrack

;Save OIDs
Int SaveOneID
Int SaveTwoID
Int SaveThreeID
Int SaveFourID
Int SaveFiveID

;Load OIDs
Int LoadOneID
Int LoadTwoID
Int LoadThreeID
Int LoadFourID
Int LoadFiveID

;perk OIDs
Int[] PerkID ;en masse perk toggle options ID
Int[] TrackID ;perk tracking ID
;stats OIDs
Int HealthID ;slider options
Int StaminaID
Int MagickaID
Int HealRateID
Int StaminaRateID
Int MagickaRateID
Int SpeedMultID
Int WeaponSpeedMultID ;for right/two-hand weapons
Int WeaponLeftSpeedMultID ;for left hand weapon
Int MagicResistID
Int FrostResistID
Int FireResistID
Int ShockResistID
Int DiseaseResistID
Int PoisonResistID
Int ShoutRecoveryMultID
Int CritChanceID
Int CarryWeightID
Int UnarmedDamageID

;perk states
Bool TrackState ;one perk tracking state shared across all of TrackID
;stats states
Float HealthState
Float StaminaState
Float MagickaState
Float HealRateState
Float StaminaRateState
Float MagickaRateState
Float SpeedMultState
Float WeaponSpeedMultState
Float WeaponLeftSpeedMultState
Float MagicResistState
Float FrostResistState
Float FireResistState
Float ShockResistState
Float DiseaseResistState
Float PoisonResistState
Float ShoutRecoveryMultState
Float CritChanceState
Float CarryWeightState
Float UnarmedDamageState

;Default value vars
Float HealthDef
Float StaminaDef
Float MagickaDef
Float CarryWeightDef
Float HealRateDef
Float StaminaRateDef
Float MagickaRateDef
Float SpeedMultDef
Float ShoutRecoveryMultDef
Float CritChanceDef
Float WeaponSpeedMultDef
Float WeaponLeftSpeedMultDef
Float MagicResistDef
Float FrostResistDef
Float FireResistDef
Float ShockResistDef
Float DiseaseResistDef
Float PoisonResistDef
Float UnarmedDamageDef

Event OnConfigInit()
	Log("Initializing SCP version " + GetVersion() as String, 1)
	
	;Dependency version checks
	Bool isJCValid = JContainers.APIVersion() == JC_API_Version
	If !(isJCValid)
		Log("JContainers version mismatch.", 2)
		Log("JContainers version expected: " + JC_API_Version as String, 2)
		Log("JContainers version found: " + JContainers.APIVersion() as String, 2)
		MBox("Stat Control Panel did not find the required version of JContainers. Not all features may function appropriately.")
	EndIf

	;Set slider defaults to conform with players racial bonuses
	PlayerRace = PlayerRef.GetRace()
	SetRacialDefaults()

	;Initialize OID array for en masse add/remove options
	perkID = New Int[36]
	
	;Initialize OID array for perk tracking toggles.
	TrackID = New Int[19]
	
	;Perk toggle OIDs
	AlchemyPerksID = New Int[15]
	AlterationPerksID = New Int[14]
	ArcheryPerksID = New Int[16]
	BlockPerksID = New Int[13]
	ConjurationPerksID = New Int[16]
	DestructionPerksID = New Int[17]
	EnchantingPerksID = New Int[13]
	HeavyArmorPerksID = New Int[12]
	IllusionPerksID = New Int[13]
	LightArmorPerksID = New Int[10]
	LockpickingPerksID = New Int[11]
	OneHandedPerksID = New Int[21]
	PickpocketPerksID = New Int[12]
	RestorationPerksID = New Int[13]
	SmithingPerksID = New Int[10]
	SneakPerksID = New Int[13]
	SpeechPerksID = New Int[13]
	TwoHandedPerksID = New Int[19]

	;Perk toggle states
	AlchemyPerksState = New Bool[15]
	AlterationPerksState = New Bool[14]
	ArcheryPerksState = New Bool[16]
	BlockPerksState = New Bool[13]
	ConjurationPerksState = New Bool[16]
	DestructionPerksState = New Bool[17]
	EnchantingPerksState = New Bool[13]
	HeavyArmorPerksState = New Bool[12]
	IllusionPerksState = New Bool[13]
	LightArmorPerksState = New Bool[10]
	LockpickingPerksState = New Bool[11]
	OneHandedPerksState = New Bool[21]
	PickpocketPerksState = New Bool[12]
	RestorationPerksState = New Bool[13]
	SmithingPerksState = New Bool[10]
	SneakPerksState = New Bool[13]
	SpeechPerksState = New Bool[13]
	TwoHandedPerksState = New Bool[19]

	;Initialize perk tracker arrays
	AlchemyPerksTrack = New Bool[15]
	AlterationPerksTrack = New Bool[14]
	ArcheryPerksTrack = New Bool[16]
	BlockPerksTrack = New Bool[13]
	ConjurationPerksTrack = New Bool[16]
	DestructionPerksTrack = New Bool[17]
	EnchantingPerksTrack = New Bool[13]
	HeavyArmorPerksTrack = New Bool[12]
	IllusionPerksTrack = New Bool[13]
	LightArmorPerksTrack = New Bool[10]
	LockpickingPerksTrack = New Bool[11]
	OneHandedPerksTrack = New Bool[21]
	PickpocketPerksTrack = New Bool[12]
	RestorationPerksTrack = New Bool[13]
	SmithingPerksTrack = New Bool[10]
	SneakPerksTrack = New Bool[13]
	SpeechPerksTrack = New Bool[13]
	TwoHandedPerksTrack = New Bool[19]
	
	Pages = New String[20]
	Pages[0] = "General"
	Pages[1] = "Stats"
	Pages[2] = "Alchemy"
	Pages[3] = "Alteration"
	Pages[4] = "Archery"
	Pages[5] = "Block"
	Pages[6] = "Conjuration"
	Pages[7] = "Destruction"
	Pages[8] = "Enchanting"
	Pages[9] = "Heavy Armor"
	Pages[10] = "Illusion"
	Pages[11] = "Light Armor"
	Pages[12] = "Lockpicking"
	Pages[13] = "One Handed"
	Pages[14] = "Pickpocket"
	Pages[15] = "Restoration"
	Pages[16] = "Smithing"
	Pages[17] = "Sneak"
	Pages[18] = "Speech"
	Pages[19] = "Two Handed"
EndEvent

Event OnVersionUpdate(Int SCP_Version)
	;Call OnConfigInit if a newer version is detected to incorporate any new changes.
	;CurrentVersion comes from MCM api and stores the last ran version (from GetVersion) of this script
	If (SCP_Version > CurrentVersion) && (CurrentVersion > 1)
		Log("Running version update", 1)
	
		;calling OnConfigInit will wipe arrays initialised there
		;store current perk tracking arrays into temporary containers.
		Bool[] alc = AlchemyPerksTrack
		Bool[] alt = AlterationPerksTrack
		Bool[] arc = ArcheryPerksTrack
		Bool[] blo = BlockPerksTrack
		Bool[] con = ConjurationPerksTrack
		Bool[] des = DestructionPerksTrack
		Bool[] enc = EnchantingPerksTrack
		Bool[] hea = HeavyArmorPerksTrack
		Bool[] ill = IllusionPerksTrack
		Bool[] lig = LightArmorPerksTrack
		Bool[] loc = LockpickingPerksTrack
		Bool[] one = OneHandedPerksTrack
		Bool[] pic = PickpocketPerksTrack
		Bool[] res = RestorationPerksTrack
		Bool[] smi = SmithingPerksTrack
		Bool[] sne = SneakPerksTrack
		Bool[] spe = SpeechPerksTrack
		Bool[] two = TwoHandedPerksTrack
		
		OnConfigInit()
		
		;restore perk trackers to their pre-update state
		AlchemyPerksTrack = alc
		AlterationPerksTrack = alt
		ArcheryPerksTrack = arc
		BlockPerksTrack = blo
		ConjurationPerksTrack = con
		DestructionPerksTrack = des
		EnchantingPerksTrack = enc
		HeavyArmorPerksTrack = hea
		IllusionPerksTrack = ill
		LightArmorPerksTrack = lig
		LockpickingPerksTrack = loc
		OneHandedPerksTrack = one
		PickpocketPerksTrack = pic
		RestorationPerksTrack = res
		SmithingPerksTrack = smi
		SneakPerksTrack = sne
		SpeechPerksTrack = spe
		TwoHandedPerksTrack = two
		
		Log("Stat Control Panel has been updated from version " + CurrentVersion as String + "  to version " + SCP_Version as String, 1)
		Notify("Stat Control Panel has been updated to version " + SCP_Version as String)
	EndIf

EndEvent

Event OnPageReset(String aPage)
	;Set the elements to display when a page/panel is selected
	
	If (aPage == "General")
		;General mod options
		
		Bool isJCValid = JContainers.APIVersion() == JC_API_Version
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		AddHeaderOption("SCP Version: " + GetVersion() as String)
		AddHeaderOption("Valid JContainers version: " + isJCValid as String)
		TrackID[18] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		AddHeaderOption("Save")
		AddHeaderOption("Load")
		SaveOneID = AddTextOption("Slot 1", "")
		LoadOneID = AddTextOption("Slot 1", "")
		SaveTwoID = AddTextOption("Slot 2", "")
		LoadTwoID = AddTextOption("Slot 2", "")
		SaveThreeID = AddTextOption("Slot 3", "")
		LoadThreeID = AddTextOption("Slot 3", "")
		
	EndIf
		
	If (aPage == "Stats")
	
		;Check that the player hasn't changed their race
		If (PlayerRace != PlayerRef.GetRace())
			PlayerRace = PlayerRef.GetRace()
			SetRacialDefaults()
		EndIf
		
		;Get the current values of stats to properly display on the sliders
		HealthState = PlayerRef.GetBaseActorValue("health")
		StaminaState = PlayerRef.GetBaseActorValue("stamina")
		MagickaState = PlayerRef.GetBaseActorValue("magicka")
		HealRateState = PlayerRef.GetActorValue("healrate")
		StaminaRateState = PlayerRef.GetActorValue("staminarate")
		MagickaRateState = PlayerRef.GetActorValue("magickarate")
		SpeedMultState = PlayerRef.GetActorValue("speedmult")
		WeaponSpeedMultState = PlayerRef.GetActorValue("weaponspeedmult")
		WeaponLeftSpeedMultState = PlayerRef.GetActorValue("leftweaponspeedmult")
		MagicResistState = PlayerRef.GetActorValue("magicresist")
		FrostResistState = PlayerRef.GetActorValue("frostresist")
		FireResistState = PlayerRef.GetActorValue("fireresist")
		ShockResistState = PlayerRef.GetActorValue("electricresist")
		DiseaseResistState = PlayerRef.GetActorValue("diseaseresist")
		PoisonResistState = PlayerRef.GetActorValue("poisonresist")
		ShoutRecoveryMultState = PlayerRef.GetActorValue("shoutrecoverymult")
		CritChanceState = PlayerRef.GetActorValue("critchance")
		UnarmedDamageState = PlayerRef.GetActorValue("unarmeddamage")
		CarryWeightState = PlayerRef.GetActorValue("carryweight")
		
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetCursorPosition(0)
		AddHeaderOption("Primary Stats")
		HealthID = AddSliderOption("Max Health", HealthState, "{0}")
		StaminaID = AddSliderOption("Max Stamina", StaminaState, "{0}")
		MagickaID = AddSliderOption("Max Magicka", MagickaState, "{0}")
		
		AddHeaderOption("Resistance Stats")
		MagicResistID = AddSliderOption("Magic Resist", MagicResistState, "{0}")
		ShockResistID = AddSliderOption("Shock Resist", ShockResistState, "{0}")
		DiseaseResistID = AddSliderOption("Disease Resist", DiseaseResistState, "{0}")
		
		AddHeaderOption("Combat Stats")
		WeaponSpeedMultID = AddSliderOption("Weapon Speed", WeaponSpeedMultState, "{2}")
		ShoutRecoveryMultID = AddSliderOption("Shout Recovery", ShoutRecoveryMultState, "{1}")
		CritChanceID = AddSliderOption("Critical Chance", CritChanceState, "{0}")
		
		AddHeaderOption("Misc")
		CarryWeightID = AddSliderOption("Carry Weight", CarryWeightState, "{0}")
		
		SetCursorPosition(1)
		AddEmptyOption() ;Primary Stats
		HealRateID = AddSliderOption("Health Regen Rate", HealRateState, "{1}")
		StaminaRateID = AddSliderOption("Stamina Regen Rate", StaminaRateState, "{1}")
		MagickaRateID = AddSliderOption("Magicka Regen Rate", MagickaRateState, "{1}")
		
		AddEmptyOption() ;Resists
		FireResistID = AddSliderOption("Fire Resist", FireResistState, "{0}")
		FrostResistID = AddSliderOption("Frost Resist", FrostResistState, "{0}")
		PoisonResistID = AddSliderOption("Poison Resist", PoisonResistState, "{0}")
		
		AddEmptyOption() ;Combat Stats
		WeaponLeftSpeedMultID = AddSliderOption("Left Weapon Speed", WeaponLeftSpeedMultState, "{2}")
		UnarmedDamageID = AddSliderOption("Unarmed Damage", UnarmedDamageState, "{0}")
		AddEmptyOption()
		
		AddEmptyOption() ;Misc
		SpeedMultID = AddSliderOption("Move Speed", SpeedMultState, "{0}")
		
	EndIf

	If (aPage == "Alchemy")
	
		;Get the current state of Alchemy perks for proper display of toggle options
		UpdatePerkStates("Alchemy")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[0] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[0] = AddTextOption("Enable All Alchemy Perks", "")
		PerkID[1] = AddTextOption("Disable All Alchemy Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		AlchemyPerksID[0] = AddToggleOption("Alchemist Rank 1", AlchemyPerksState[0])
		AlchemyPerksID[1] = AddToggleOption("Alchemist Rank 2", AlchemyPerksState[1])
		AlchemyPerksID[2] = AddToggleOption("Alchemist Rank 3", AlchemyPerksState[2])
		AlchemyPerksID[3] = AddToggleOption("Alchemist Rank 4", AlchemyPerksState[3])
		AlchemyPerksID[4] = AddToggleOption("Alchemist Rank 5", AlchemyPerksState[4])
		AlchemyPerksID[5] = AddToggleOption("Physician", AlchemyPerksState[5])
		AlchemyPerksID[6] = AddToggleOption("Benefactor", AlchemyPerksState[6])
		AlchemyPerksID[7] = AddToggleOption("Poisoner", AlchemyPerksState[7])
		AlchemyPerksID[8] = AddToggleOption("Experimenter Rank 1", AlchemyPerksState[8])
		AlchemyPerksID[9] = AddToggleOption("Experimenter Rank 2", AlchemyPerksState[9])
		AlchemyPerksID[10] = AddToggleOption("Experimenter Rank 3", AlchemyPerksState[10])
		AlchemyPerksID[11] = AddToggleOption("Concentrated Poison", AlchemyPerksState[11])
		AlchemyPerksID[12] = AddToggleOption("Green Thumb", AlchemyPerksState[12])
		AlchemyPerksID[13] = AddToggleOption("Snakeblood", AlchemyPerksState[13])
		AlchemyPerksID[14] = AddToggleOption("Purity", AlchemyPerksState[14])
		
	EndIf
	
	If (aPage == "Alteration")
	
		;Get the current state of Alteration perks for propery display of toggle options
		UpdatePerkStates("Alteration")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[1] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[2] = AddTextOption("Enable All Alteration Perks", "")
		PerkID[3] = AddTextOption("Disable All Alteration Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		AlterationPerksID[0] = AddToggleOption("Novice Alteration", AlterationPerksState[0])
		AlterationPerksID[1] = AddToggleOption("Alteration Dual Casting", AlterationPerksState[1])
		AlterationPerksID[2] = AddToggleOption("Apprentice Alteration", AlterationPerksState[2])
		AlterationPerksID[3] = AddToggleOption("Mage Armor 1", AlterationPerksState[3])
		AlterationPerksID[4] = AddToggleOption("Mage Armor 2", AlterationPerksState[4])
		AlterationPerksID[5] = AddToggleOption("Mage Armor 3", AlterationPerksState[5])
		AlterationPerksID[6] = AddToggleOption("Magic Resistance 1", AlterationPerksState[6])
		AlterationPerksID[7] = AddToggleOption("Magic Resistance 2", AlterationPerksState[7])
		AlterationPerksID[8] = AddToggleOption("Magic Resistance 3", AlterationPerksState[8])
		AlterationPerksID[9] = AddToggleOption("Adept Alteration", AlterationPerksState[9])
		AlterationPerksID[10] = AddToggleOption("Stability", AlterationPerksState[10])
		AlterationPerksID[11] = AddToggleOption("Expert Alteration", AlterationPerksState[11])
		AlterationPerksID[12] = AddToggleOption("Atronach", AlterationPerksState[12])
		AlterationPerksID[13] = AddToggleOption("Master Alteration", AlterationPerksState[13])
		
	EndIf
	
	If (aPage == "Archery")
	
		;Get the current state of Archery perks for propery display of toggle options
		UpdatePerkStates("Archery")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[2] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[4] = AddTextOption("Enable All Archery Perks", "")
		PerkID[5] = AddTextOption("Disable All Archery Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		ArcheryPerksID[0] = AddToggleOption("Overdraw Rank 1", ArcheryPerksState[0])
		ArcheryPerksID[1] = AddToggleOption("OverDraw Rank 2", ArcheryPerksState[1])
		ArcheryPerksID[2] = AddToggleOption("OverDraw Rank 3", ArcheryPerksState[2])
		ArcheryPerksID[3] = AddToggleOption("Overdraw Rank 4", ArcheryPerksState[3])
		ArcheryPerksID[4] = AddToggleOption("OverDraw Rank 5", ArcheryPerksState[4])
		ArcheryPerksID[5] = AddToggleOption("Critical Shot 1", ArcheryPerksState[5])
		ArcheryPerksID[6] = AddToggleOption("Critical Shot 2", ArcheryPerksState[6])
		ArcheryPerksID[7] = AddToggleOption("Critical Shot 3", ArcheryPerksState[7])
		ArcheryPerksID[8] = AddToggleOption("Eagle Eye", ArcheryPerksState[8])
		ArcheryPerksID[9] = AddToggleOption("Steady Hand Rank 1", ArcheryPerksState[9])
		ArcheryPerksID[10] = AddToggleOption("Steady Hand Rank 2", ArcheryPerksState[10])
		ArcheryPerksID[11] = AddToggleOption("Hunter's Discipline", ArcheryPerksState[11])
		ArcheryPerksID[12] = AddToggleOption("Power Shot", ArcheryPerksState[12])
		ArcheryPerksID[13] = AddToggleOption("Ranger", ArcheryPerksState[13])
		ArcheryPerksID[14] = AddToggleOption("Quick Shot", ArcheryPerksState[14])
		ArcheryPerksID[15] = AddToggleOption("Bullseye", ArcheryPerksState[15])
		
	EndIf
	
	If (aPage == "Block")
	
		;Get the current state of Block perks for propery display of toggle options
		UpdatePerkStates("Block")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[3] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[6] = AddTextOption("Enable All Block Perks", "")
		PerkID[7] = AddTextOption("Disable All Block Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		BlockPerksID[0] = AddToggleOption("Shield Wall Rank 1", BlockPerksState[0])
		BlockPerksID[1] = AddToggleOption("Shield Wall Rank 2", BlockPerksState[1])
		BlockPerksID[2] = AddToggleOption("Shield Wall Rank 3", BlockPerksState[2])
		BlockPerksID[3] = AddToggleOption("Shield Wall Rank 4", BlockPerksState[3])
		BlockPerksID[4] = AddToggleOption("Shield Wall Rank 5", BlockPerksState[4])
		BlockPerksID[5] = AddToggleOption("Deflect Arrows", BlockPerksState[5])
		BlockPerksID[6] = AddToggleOption("Power Bash", BlockPerksState[6])
		BlockPerksID[7] = AddToggleOption("Quick Reflexes", BlockPerksState[7])
		BlockPerksID[8] = AddToggleOption("Deadly bash", BlockPerksState[8])
		BlockPerksID[9] = AddToggleOption("Elemental Protection", BlockPerksState[9])
		BlockPerksID[10] = AddToggleOption("Block Runner", BlockPerksState[10])
		BlockPerksID[11] = AddToggleOption("Disarming Bash", BlockPerksState[11])
		BlockPerksID[12] = AddToggleOption("Shield Charge", BlockPerksState[12])
		
	EndIf
	
	If (aPage == "Conjuration")
	
		;Get the current state of Conjuration perks for propery display of toggle options
		UpdatePerkStates("Conjuration")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[4] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[8] = AddTextOption("Enable All Conjuration Perks", "")
		PerkID[9] = AddTextOption("Disable All Conjuration Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		ConjurationPerksID[0] = AddToggleOption("Novice Conjuration", ConjurationPerksState[0])
		ConjurationPerksID[1] = AddToggleOption("Conjuration Dual Casting", ConjurationPerksState[1])
		ConjurationPerksID[2] = AddToggleOption("Mystic Binding", ConjurationPerksState[2])
		ConjurationPerksID[3] = AddToggleOption("Apprentice Conjuration", ConjurationPerksState[3])
		ConjurationPerksID[4] = AddToggleOption("Soul Stealer", ConjurationPerksState[4])
		ConjurationPerksID[5] = AddToggleOption("Summoner Rank 1", ConjurationPerksState[5])
		ConjurationPerksID[6] = AddToggleOption("Summoner Rank 2", ConjurationPerksState[6])
		ConjurationPerksID[7] = AddToggleOption("Atromancy", ConjurationPerksState[7])
		ConjurationPerksID[8] = AddToggleOption("Necromancy", ConjurationPerksState[8])
		ConjurationPerksID[9] = AddToggleOption("Adept Conjuration", ConjurationPerksState[9])
		ConjurationPerksID[10] = AddToggleOption("Oblivion Binding", ConjurationPerksState[10])
		ConjurationPerksID[11] = AddToggleOption("Dark Souls", ConjurationPerksState[11])
		ConjurationPerksID[12] = AddToggleOption("Expert Conjuration", ConjurationPerksState[12])
		ConjurationPerksID[13] = AddToggleOption("Elemental Potency", ConjurationPerksState[13])
		ConjurationPerksID[14] = AddToggleOption("Master Conjuration", ConjurationPerksState[14])
		ConjurationPerksID[15] = AddToggleOption("Twin Souls", ConjurationPerksState[15])
		
	EndIf
	
	If (aPage == "Destruction")
	
		;Get the current state of Destruction perks for propery display of toggle options
		UpdatePerkStates("Destruction")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[5] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[10] = AddTextOption("Enable All Destruction Perks", "")
		PerkID[11] = AddTextOption("Disable All Destruction Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		DestructionPerksID[0] = AddToggleOption("Novice Destruction", DestructionPerksState[0])
		DestructionPerksID[1] = AddToggleOption("Destruction Dual Casting", DestructionPerksState[1])
		DestructionPerksID[2] = AddToggleOption("Apprentice Destruction", DestructionPerksState[2])
		DestructionPerksID[3] = AddToggleOption("Augmented Flames Rank 1", DestructionPerksState[3])
		DestructionPerksID[4] = AddToggleOption("Augmented Flames Rank 2", DestructionPerksState[4])
		DestructionPerksID[5] = AddToggleOption("Augmented Frost Rank 1", DestructionPerksState[5])
		DestructionPerksID[6] = AddToggleOption("Augmented Frost Rank 2", DestructionPerksState[6])
		DestructionPerksID[7] = AddToggleOption("Augmented Shock Rank 1", DestructionPerksState[7])
		DestructionPerksID[8] = AddToggleOption("Augmented Shock Rank 2", DestructionPerksState[8])
		DestructionPerksID[9] = AddToggleOption("Impact", DestructionPerksState[9])
		DestructionPerksID[10] = AddToggleOption("Rune Master", DestructionPerksState[10])
		DestructionPerksID[11] = AddToggleOption("Adept Destruction", DestructionPerksState[11])
		DestructionPerksID[12] = AddToggleOption("Intense Flames", DestructionPerksState[12])
		DestructionPerksID[13] = AddToggleOption("Deep Freeze", DestructionPerksState[13])
		DestructionPerksID[14] = AddToggleOption("Disintigrate", DestructionPerksState[14])
		DestructionPerksID[15] = AddToggleOption("Expert Destruction", DestructionPerksState[15])
		DestructionPerksID[16] = AddToggleOption("Master Destruction", DestructionPerksState[16])
		
	EndIf
	
	If (aPage == "Enchanting")
	
		;Get the current state of Enchanting perks for propery display of toggle options
		UpdatePerkStates("Enchanting")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[6] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[12] = AddTextOption("Enable All Enchanting Perks", "")
		PerkID[13] = AddTextOption("Disable All Enchanting Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		EnchantingPerksID[0] = AddToggleOption("Enchanter Rank 1", EnchantingPerksState[0])
		EnchantingPerksID[1] = AddToggleOption("Enchanter Rank 2", EnchantingPerksState[1])
		EnchantingPerksID[2] = AddToggleOption("Enchanter Rank 3", EnchantingPerksState[2])
		EnchantingPerksID[3] = AddToggleOption("Enchanter Rank 4", EnchantingPerksState[3])
		EnchantingPerksID[4] = AddToggleOption("Enchanter Rank 5", EnchantingPerksState[4])
		EnchantingPerksID[5] = AddToggleOption("Soul Squeezer", EnchantingPerksState[5])
		EnchantingPerksID[6] = AddToggleOption("Fire Enchanter", EnchantingPerksState[6])
		EnchantingPerksID[7] = AddToggleOption("Frost Enchanter", EnchantingPerksState[7])
		EnchantingPerksID[8] = AddToggleOption("Soul Siphon", EnchantingPerksState[8])
		EnchantingPerksID[9] = AddToggleOption("Insightful Enchanter", EnchantingPerksState[9])
		EnchantingPerksID[10] = AddToggleOption("Storm Enchanter", EnchantingPerksState[10])
		EnchantingPerksID[11] = AddToggleOption("Corpus Enchanter", EnchantingPerksState[11])
		EnchantingPerksID[12] = AddToggleOption("Extra Effect", EnchantingPerksState[12])
		
	EndIf
	
	If (aPage == "Heavy Armor")
	
		;Get the current state of HeavyArmor perks for propery display of toggle options
		UpdatePerkStates("HeavyArmor")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[7] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[14] = AddTextOption("Enable All Heavy Armor Perks", "")
		PerkID[15] = AddTextOption("Disable All Heavy Armor Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		HeavyArmorPerksID[0] = AddToggleOption("Juggernaut Rank 1", HeavyArmorPerksState[0])
		HeavyArmorPerksID[1] = AddToggleOption("Juggernaut Rank 2", HeavyArmorPerksState[1])
		HeavyArmorPerksID[2] = AddToggleOption("Juggernaut Rank 3", HeavyArmorPerksState[2])
		HeavyArmorPerksID[3] = AddToggleOption("Juggernaut Rank 4", HeavyArmorPerksState[3])
		HeavyArmorPerksID[4] = AddToggleOption("Juggernaut Rank 5", HeavyArmorPerksState[4])
		HeavyArmorPerksID[5] = AddToggleOption("Fists of Steel", HeavyArmorPerksState[5])
		HeavyArmorPerksID[6] = AddToggleOption("Well Fitted", HeavyArmorPerksState[6])
		HeavyArmorPerksID[7] = AddToggleOption("Cushioned", HeavyArmorPerksState[7])
		HeavyArmorPerksID[8] = AddToggleOption("Tower of Strength", HeavyArmorPerksState[8])
		HeavyArmorPerksID[9] = AddToggleOption("Conditioning", HeavyArmorPerksState[9])
		HeavyArmorPerksID[10] = AddToggleOption("Matching set", HeavyArmorPerksState[10])
		HeavyArmorPerksID[11] = AddToggleOption("Reflecting Blows", HeavyArmorPerksState[11])
		
	EndIf
	
	If (aPage == "Illusion")
	
		;Get the current state of Illusion perks for propery display of toggle options
		UpdatePerkStates("Illusion")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[8] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[16] = AddTextOption("Enable All Illusion Perks", "")
		PerkID[17] = AddTextOption("Disable All Illusion Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		IllusionPerksID[0] = AddToggleOption("Novice Illusion", IllusionPerksState[0])
		IllusionPerksID[1] = AddToggleOption("Animage", IllusionPerksState[1])
		IllusionPerksID[2] = AddToggleOption("Illusion Dual casting", IllusionPerksState[2])
		IllusionPerksID[3] = AddToggleOption("Apprentice Illusion", IllusionPerksState[3])
		IllusionPerksID[4] = AddToggleOption("Hypnotic Gaze", IllusionPerksState[4])
		IllusionPerksID[5] = AddToggleOption("Kindred Mage", IllusionPerksState[5])
		IllusionPerksID[6] = AddToggleOption("Adept Illusion", IllusionPerksState[6])
		IllusionPerksID[7] = AddToggleOption("Aspect of Terror", IllusionPerksState[7])
		IllusionPerksID[8] = AddToggleOption("Quiet Casting", IllusionPerksState[8])
		IllusionPerksID[9] = AddToggleOption("Rage", IllusionPerksState[9])
		IllusionPerksID[10] = AddToggleOption("Expert Illusion", IllusionPerksState[10])
		IllusionPerksID[11] = AddToggleOption("Master of the Mind", IllusionPerksState[11])
		IllusionPerksID[12] = AddToggleOption("Master Illusion", IllusionPerksState[12])
		
	EndIf
	
	If (aPage == "Light Armor")
	
		;Get the current state of LightArmor perks for propery display of toggle options
		UpdatePerkStates("LightArmor")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[9] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[18] = AddTextOption("Enable All Light Armor Perks", "")
		PerkID[19] = AddTextOption("Disable All Light Armor Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		LightArmorPerksID[0] = AddToggleOption("Agile Defender Rank 1", LightArmorPerksState[0])
		LightArmorPerksID[1] = AddToggleOption("Agile Defender Rank 2", LightArmorPerksState[1])
		LightArmorPerksID[2] = AddToggleOption("Agile Defender Rank 3", LightArmorPerksState[2])
		LightArmorPerksID[3] = AddToggleOption("Agile Defender Rank 4", LightArmorPerksState[3])
		LightArmorPerksID[4] = AddToggleOption("Agile Defender Rank 5", LightArmorPerksState[4])
		LightArmorPerksID[5] = AddToggleOption("Custom Fit", LightArmorPerksState[5])
		LightArmorPerksID[6] = AddToggleOption("Unhindered", LightArmorPerksState[6])
		LightArmorPerksID[7] = AddToggleOption("Wind Walker", LightArmorPerksState[7])
		LightArmorPerksID[8] = AddToggleOption("Matching Set", LightArmorPerksState[8])
		LightArmorPerksID[9] = AddToggleOption("Deft Movement", LightArmorPerksState[9])
		
	EndIf
	
	If (aPage == "Lockpicking")
	
		;Get the current state of Lockpicking perks for propery display of toggle options
		UpdatePerkStates("Lockpicking")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[10] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[20] = AddTextOption("Enable All Lockpicking Perks", "")
		PerkID[21] = AddTextOption("Disable All Lockpicking Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		LockpickingPerksID[0] = AddToggleOption("Novice Locks", LockpickingPerksState[0])
		LockpickingPerksID[1] = AddToggleOption("Apprentice Locks", LockpickingPerksState[1])
		LockpickingPerksID[2] = AddToggleOption("Quick Hands", LockpickingPerksState[2])
		LockpickingPerksID[3] = AddToggleOption("Adept Locks", LockpickingPerksState[3])
		LockpickingPerksID[4] = AddToggleOption("Wax Key", LockpickingPerksState[4])
		LockpickingPerksID[5] = AddToggleOption("Golden Touch", LockpickingPerksState[5])
		LockpickingPerksID[6] = AddToggleOption("Treasure Hunter", LockpickingPerksState[6])
		LockpickingPerksID[7] = AddToggleOption("Expert Locks", LockpickingPerksState[7])
		LockpickingPerksID[8] = AddToggleOption("Locksmith", LockpickingPerksState[8])
		LockpickingPerksID[9] = AddToggleOption("Master Locks", LockpickingPerksState[9])
		LockpickingPerksID[10] = AddToggleOption("Unbreakable", LockpickingPerksState[10])

	EndIf
	
	If (aPage == "One Handed")
	
		;Get the current state of OneHanded perks for propery display of toggle options
		UpdatePerkStates("OneHanded")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[11] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[22] = AddTextOption("Enable All One Handed Perks", "")
		PerkID[23] = AddTextOption("Disable All One Handed Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		OneHandedPerksID[0] = AddToggleOption("Armsman Rank 1", OneHandedPerksState[0])
		OneHandedPerksID[1] = AddToggleOption("Armsman Rank 2", OneHandedPerksState[1])
		OneHandedPerksID[2] = AddToggleOption("Armsman Rank 3", OneHandedPerksState[2])
		OneHandedPerksID[3] = AddToggleOption("Armsman Rank 4", OneHandedPerksState[3])
		OneHandedPerksID[4] = AddToggleOption("Armsman Rank 5", OneHandedPerksState[4])
		OneHandedPerksID[5] = AddToggleOption("Fighting Stance", OneHandedPerksState[5])
		OneHandedPerksID[6] = AddToggleOption("Bladesman 1", OneHandedPerksState[6])
		OneHandedPerksID[7] = AddToggleOption("Bladesman 2", OneHandedPerksState[7])
		OneHandedPerksID[8] = AddToggleOption("Bladesman 3", OneHandedPerksState[8])
		OneHandedPerksID[9] = AddToggleOption("Bone Breaker 1", OneHandedPerksState[9])
		OneHandedPerksID[10] = AddToggleOption("Bone Breaker 2", OneHandedPerksState[10])
		OneHandedPerksID[11] = AddToggleOption("Bone Breaker 3", OneHandedPerksState[11])
		OneHandedPerksID[12] = AddToggleOption("Dual Flurry 1", OneHandedPerksState[12])
		OneHandedPerksID[13] = AddToggleOption("Dual Flurry 2", OneHandedPerksState[13])
		OneHandedPerksID[14] = AddToggleOption("Hack and Slash Rank 1", OneHandedPerksState[14])
		OneHandedPerksID[15] = AddToggleOption("Hack and Slash Rank 2", OneHandedPerksState[15])
		OneHandedPerksID[16] = AddToggleOption("Hack and Slash Rank 3", OneHandedPerksState[16])
		OneHandedPerksID[17] = AddToggleOption("Critical Charge", OneHandedPerksState[17])
		OneHandedPerksID[18] = AddToggleOption("Savage Strike", OneHandedPerksState[18])
		OneHandedPerksID[19] = AddToggleOption("Dual Savagery", OneHandedPerksState[19])
		OneHandedPerksID[20] = AddToggleOption("Paralyzing Strike", OneHandedPerksState[20])
		
	EndIf
	
	If (aPage == "Pickpocket")
	
		;Get the current state of Pickpocket perks for propery display of toggle options
		UpdatePerkStates("Pickpocket")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[12] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[24] = AddTextOption("Enable All Pickpocket Perks", "")
		PerkID[25] = AddTextOption("Disable All Pickpocket Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		PickpocketPerksID[0] = AddToggleOption("Light Fingers 1", PickpocketPerksState[0])
		PickpocketPerksID[1] = AddToggleOption("Light Fingers 2", PickpocketPerksState[1])
		PickpocketPerksID[2] = AddToggleOption("Light Fingers 3", PickpocketPerksState[2])
		PickpocketPerksID[3] = AddToggleOption("Light Fingers 4", PickpocketPerksState[3])
		PickpocketPerksID[4] = AddToggleOption("Light Fingers 5", PickpocketPerksState[4])
		PickpocketPerksID[5] = AddToggleOption("Night Thief", PickpocketPerksState[5])
		PickpocketPerksID[6] = AddToggleOption("Cutpurse", PickpocketPerksState[6])
		PickpocketPerksID[7] = AddToggleOption("Poisoned", PickpocketPerksState[7])
		PickpocketPerksID[8] = AddToggleOption("Extra Pockets", PickpocketPerksState[8])
		PickpocketPerksID[9] = AddToggleOption("Keymaster", PickpocketPerksState[9])
		PickpocketPerksID[10] = AddToggleOption("Misdirection", PickpocketPerksState[10])
		PickpocketPerksID[11] = AddToggleOption("Perfect Touch", PickpocketPerksState[11])
		
	EndIf
	
	If (aPage == "Restoration")
	
		;Get the current state of Restoration perks for propery display of toggle options
		UpdatePerkStates("Restoration")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[13] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[26] = AddTextOption("Enable All Restoration Perks", "")
		PerkID[27] = AddTextOption("Disable All Restoration Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		RestorationPerksID[0] = AddToggleOption("Novice Restoration", RestorationPerksState[0])
		RestorationPerksID[1] = AddToggleOption("Regeneration", RestorationPerksState[1])
		RestorationPerksID[2] = AddToggleOption("Restoration Dual Casting", RestorationPerksState[2])
		RestorationPerksID[3] = AddToggleOption("Apprentice Restoration", RestorationPerksState[3])
		RestorationPerksID[4] = AddToggleOption("Recovery Rank 1", RestorationPerksState[4])
		RestorationPerksID[5] = AddToggleOption("Recovery Rank 2", RestorationPerksState[5])
		RestorationPerksID[6] = AddToggleOption("Respite", RestorationPerksState[6])
		RestorationPerksID[7] = AddToggleOption("Adept Restoration", RestorationPerksState[7])
		RestorationPerksID[8] = AddToggleOption("Ward Absorb", RestorationPerksState[8])
		RestorationPerksID[9] = AddToggleOption("Necromage", RestorationPerksState[9])
		RestorationPerksID[10] = AddToggleOption("Expert Restoration", RestorationPerksState[10])
		RestorationPerksID[11] = AddToggleOption("Avoid Death", RestorationPerksState[11])
		RestorationPerksID[12] = AddToggleOption("Master Restoration", RestorationPerksState[12])
		
	EndIf
	
	If (aPage == "Smithing")
	
		;Get the current state of Smithing perks for propery display of toggle options
		UpdatePerkStates("Smithing")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[14] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[28] = AddTextOption("Enable All Smithing Perks", "")
		PerkID[29] = AddTextOption("Disable All Smithing Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		SmithingPerksID[0] = AddToggleOption("Steel Smithing", SmithingPerksState[0])
		SmithingPerksID[1] = AddToggleOption("Dwarven Smithing", SmithingPerksState[1])
		SmithingPerksID[2] = AddToggleOption("Elven Smithing", SmithingPerksState[2])
		SmithingPerksID[3] = AddToggleOption("Advanced Armors", SmithingPerksState[3])
		SmithingPerksID[4] = AddToggleOption("Orcish Smithing", SmithingPerksState[4])
		SmithingPerksID[5] = AddToggleOption("Arcane Blacksmith", SmithingPerksState[5])
		SmithingPerksID[6] = AddToggleOption("Glass Smithing", SmithingPerksState[6])
		SmithingPerksID[7] = AddToggleOption("Ebony Smithing", SmithingPerksState[7])
		SmithingPerksID[8] = AddToggleOption("Daedric Smithing", SmithingPerksState[8])
		SmithingPerksID[9] = AddToggleOption("Dragon Armor", SmithingPerksState[9])
		
	EndIf
	
	If (aPage == "Sneak")
	
		;Get the current state of Sneak perks for propery display of toggle options
		UpdatePerkStates("Sneak")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[15] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[30] = AddTextOption("Enable All Sneak Perks", "")
		PerkID[31] = AddTextOption("Disable All Sneak Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		SneakPerksID[0] = AddToggleOption("Stealth Rank 1", SneakPerksState[0])
		SneakPerksID[1] = AddToggleOption("Stealth Rank 2", SneakPerksState[1])
		SneakPerksID[2] = AddToggleOption("Stealth Rank 3", SneakPerksState[2])
		SneakPerksID[3] = AddToggleOption("Stealth Rank 4", SneakPerksState[3])
		SneakPerksID[4] = AddToggleOption("Stealth Rank 5", SneakPerksState[4])
		SneakPerksID[5] = AddToggleOption("Backstab", SneakPerksState[5])
		SneakPerksID[6] = AddToggleOption("Muffled Movement", SneakPerksState[6])
		SneakPerksID[7] = AddToggleOption("Deadly Aim", SneakPerksState[7])
		SneakPerksID[8] = AddToggleOption("Light Foot", SneakPerksState[8])
		SneakPerksID[9] = AddToggleOption("Assassin's Blade", SneakPerksState[9])
		SneakPerksID[10] = AddToggleOption("Silent Roll", SneakPerksState[10])
		SneakPerksID[11] = AddToggleOption("Silence", SneakPerksState[11])
		SneakPerksID[12] = AddToggleOption("Shadow Warrior", SneakPerksState[12])
		
	EndIf
	
	If (aPage == "Speech")
	
		;Get the current state of Speech perks for propery display of toggle options
		UpdatePerkStates("Speech")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[16] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[32] = AddTextOption("Enable All Speech Perks", "")
		PerkID[33] = AddTextOption("Disable All Speech Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		SpeechPerksID[0] = AddToggleOption("Haggling Rank 1", SpeechPerksState[0])
		SpeechPerksID[1] = AddToggleOption("Haggling Rank 2", SpeechPerksState[1])
		SpeechPerksID[2] = AddToggleOption("Haggling Rank 3", SpeechPerksState[2])
		SpeechPerksID[3] = AddToggleOption("Haggling Rank 4", SpeechPerksState[3])
		SpeechPerksID[4] = AddToggleOption("Haggling Rank 5", SpeechPerksState[4])
		SpeechPerksID[5] = AddToggleOption("Allure", SpeechPerksState[5])
		SpeechPerksID[6] = AddToggleOption("Bribery", SpeechPerksState[6])
		SpeechPerksID[7] = AddToggleOption("Merchant", SpeechPerksState[7])
		SpeechPerksID[8] = AddToggleOption("Persuasion", SpeechPerksState[8])
		SpeechPerksID[9] = AddToggleOption("Intimidation", SpeechPerksState[9])
		SpeechPerksID[10] = AddToggleOption("Investor", SpeechPerksState[10])
		SpeechPerksID[11] = AddToggleOption("Fence", SpeechPerksState[11])
		SpeechPerksID[12] = AddToggleOption("Master Trader", SpeechPerksState[12])
		
	EndIf
	
	If (aPage == "Two Handed")
	
		;Get the current state of TwoHanded perks for propery display of toggle options
		UpdatePerkStates("TwoHanded")
		
		SetCursorFillMode(LEFT_TO_RIGHT)
		
		SetCursorPosition(0)
		AddHeaderOption("Options")
		AddEmptyOption()
		TrackID[17] = AddToggleOption("Enable Perk Tracking", TrackState)
		AddEmptyOption()
		PerkID[34] = AddTextOption("Enable All TwoHanded Perks", "")
		PerkID[35] = AddTextOption("Disable All TwoHanded Perks", "")
		AddHeaderOption("Perks")
		AddEmptyOption()
		TwoHandedPerksID[0] = AddToggleOption("Barbarian Rank 1", TwoHandedPerksState[0])
		TwoHandedPerksID[1] = AddToggleOption("Barbarian Rank 2", TwoHandedPerksState[1])
		TwoHandedPerksID[2] = AddToggleOption("Barbarian Rank 3", TwoHandedPerksState[2])
		TwoHandedPerksID[3] = AddToggleOption("Barbarian Rank 4", TwoHandedPerksState[3])
		TwoHandedPerksID[4] = AddToggleOption("Barbarian Rank 5", TwoHandedPerksState[4])
		TwoHandedPerksID[5] = AddToggleOption("Champion's Stance", TwoHandedPerksState[5])
		TwoHandedPerksID[6] = AddToggleOption("Deep Wounds Rank 1", TwoHandedPerksState[6])
		TwoHandedPerksID[7] = AddToggleOption("Deep Wounds Rank 2", TwoHandedPerksState[7])
		TwoHandedPerksID[8] = AddToggleOption("Deep Wounds Rank 3", TwoHandedPerksState[8])
		TwoHandedPerksID[9] = AddToggleOption("Limbsplitter Rank 1", TwoHandedPerksState[9])
		TwoHandedPerksID[10] = AddToggleOption("Limbsplitter Rank 2", TwoHandedPerksState[10])
		TwoHandedPerksID[11] = AddToggleOption("Limbsplitter Rank 3", TwoHandedPerksState[11])
		TwoHandedPerksID[12] = AddToggleOption("Skullcrusher Rank 1", TwoHandedPerksState[12])
		TwoHandedPerksID[13] = AddToggleOption("Skullcrusher Rank 2", TwoHandedPerksState[13])
		TwoHandedPerksID[14] = AddToggleOption("Skullcrusher Rank 3", TwoHandedPerksState[14])
		TwoHandedPerksID[15] = AddToggleOption("Devastating Blow", TwoHandedPerksState[15])
		TwoHandedPerksID[16] = AddToggleOption("Great Critical Charge", TwoHandedPerksState[16])
		TwoHandedPerksID[17] = AddToggleOption("Sweep", TwoHandedPerksState[17])
		TwoHandedPerksID[18] = AddToggleOption("Warmaster", TwoHandedPerksState[18])
		
	EndIf

EndEvent

Event OnOptionSelect(Int option)
	;Define the actions to take when a toggle option is selected
	
	;Save/load
	If (option == SaveOneID)
		SaveConfig("SCP_Slot_One.json")
	ElseIf (option == SaveTwoID)
		SaveConfig("SCP_Slot_Two.json")
	ElseIf (option == SaveThreeID)
		SaveConfig("SCP_Slot_Three.json")
	ElseIf (option == LoadOneID)
		LoadConfig("SCP_Slot_One.json")
		ForcePageReset()
	ElseIf (option == LoadTwoID)
		LoadConfig("SCP_Slot_Two.json")
		ForcePageReset()
	ElseIf (option == LoadThreeID)
		LoadConfig("SCP_Slot_Three.json")
		ForcePageReset()
	EndIf
	
	;Perk tracking toggles
	If (option == TrackID[0] || option == TrackID[1] || option == TrackID[2] || option == TrackID[3] || option == TrackID[4] || option == TrackID[5] || option == TrackID[6] || option == TrackID[7] || option == TrackID[8] || option == TrackID[9] || option == TrackID[10] || option == TrackID[11] || option == TrackID[12] || option == TrackID[13] || option == TrackID[14] || option == TrackID[15] || option == TrackID[16] || option == TrackID[17] || option == TrackID[18])
		TrackState = !TrackState
		ForcePageReset()
	EndIf

	;en masse add/remove options
	;Alchemy
	If (option == PerkID[0])
		AddPerksFunc(AlchemyPerks, AlchemyPerksTrack, "Alchemy")
		ForcePageReset()
	ElseIf (option == PerkID[1])
		RemovePerksFunc(AlchemyPerks, AlchemyPerksTrack, "Alchemy")
		ForcePageReset()
	;Alteration
	ElseIf (option == PerkID[2])
		AddPerksFunc(AlterationPerks, AlterationPerksTrack, "Alteration")
		ForcePageReset()
	ElseIf (option == PerkID[3])
		RemovePerksFunc(AlterationPerks, AlterationPerksTrack, "Alteration")
		ForcePageReset()
	;Archery
	ElseIf (option == PerkID[4])
		AddPerksFunc(ArcheryPerks, ArcheryPerksTrack, "Archery")
		ForcePageReset()
	ElseIf (option == PerkID[5])
		RemovePerksFunc(ArcheryPerks, ArcheryPerksTrack, "Archery")
		ForcePageReset()
	;Block
	ElseIf (option == PerkID[6])
		AddPerksFunc(BlockPerks, BlockPerksTrack, "Block")
		ForcePageReset()
	ElseIf (option == PerkID[7])
		RemovePerksFunc(BlockPerks, BlockPerksTrack, "Block")
		ForcePageReset()
	;Conjuration
	ElseIf (option == PerkID[8])
		AddPerksFunc(ConjurationPerks, ConjurationPerksTrack, "Conjuration")
		ForcePageReset()
	ElseIf (option == PerkID[9])
		RemovePerksFunc(ConjurationPerks, ConjurationPerksTrack, "Conjuration")
		ForcePageReset()
	;Destruction
	ElseIf (option == PerkID[10])
		AddPerksFunc(DestructionPerks, DestructionPerksTrack, "Destruction")
		ForcePageReset()
	ElseIf (option == PerkID[11])
		RemovePerksFunc(DestructionPerks, DestructionPerksTrack, "Destruction")
		ForcePageReset()
	;Enchanting
	ElseIf (option == PerkID[12])
		AddPerksFunc(EnchantingPerks, EnchantingPerksTrack, "Enchanting")
		ForcePageReset()
	ElseIf (option == PerkID[13])
		RemovePerksFunc(EnchantingPerks, EnchantingPerksTrack, "Enchanting")
		ForcePageReset()
	;Heavy Armor
	ElseIf (option == PerkID[14])
		AddPerksFunc(HeavyArmorPerks, HeavyArmorPerksTrack, "HeavyArmor")
		ForcePageReset()
	ElseIf (option == PerkID[15])
		RemovePerksFunc(HeavyArmorPerks, HeavyArmorPerksTrack, "HeavyArmor")
		ForcePageReset()
	;Illusion
	ElseIf (option == PerkID[16])
		AddPerksFunc(IllusionPerks, IllusionPerksTrack, "Illusion")
		ForcePageReset()
	ElseIf (option == PerkID[17])
		RemovePerksFunc(IllusionPerks, IllusionPerksTrack, "Illusion")
		ForcePageReset()
	;Light Armor
	ElseIf (option == PerkID[18])
		AddPerksFunc(LightArmorPerks, LightArmorPerksTrack, "LightArmor")
		ForcePageReset()
	ElseIf (option == PerkID[19])
		RemovePerksFunc(LightArmorPerks, LightArmorPerksTrack, "LightArmor")
		ForcePageReset()
	;Lockpicking
	ElseIf (option == PerkID[20])
		AddPerksFunc(LockpickingPerks, LockpickingPerksTrack, "Lockpicking")
		ForcePageReset()
	ElseIf (option == PerkID[21])
		RemovePerksFunc(LockpickingPerks, LockpickingPerksTrack, "Lockpicking")
		ForcePageReset()
	;One Handed
	ElseIf (option == PerkID[22])
		AddPerksFunc(OneHandedPerks, OneHandedPerksTrack, "OneHanded")
		ForcePageReset()
	ElseIf (option == PerkID[23])
		RemovePerksFunc(OneHandedPerks, OneHandedPerksTrack, "OneHanded")
		ForcePageReset()
	;Pickpocket
	ElseIf (option == PerkID[24])
		AddPerksFunc(PickpocketPerks, PickpocketPerksTrack, "Pickpocket")
		ForcePageReset()
	ElseIf (option == PerkID[25])
		RemovePerksFunc(PickpocketPerks, PickpocketPerksTrack, "Pickpocket")
		ForcePageReset()
	;Restoration
	ElseIf (option == PerkID[26])
		AddPerksFunc(RestorationPerks, RestorationPerksTrack, "Restoration")
		ForcePageReset()
	ElseIf (option == PerkID[27])
		RemovePerksFunc(RestorationPerks, RestorationPerksTrack, "Restoration")
		ForcePageReset()
	;Smithing
	ElseIf (option == PerkID[28])
		AddPerksFunc(SmithingPerks, SmithingPerksTrack, "Smithing")
		ForcePageReset()
	ElseIf (option == PerkID[29])
		RemovePerksFunc(SmithingPerks, SmithingPerksTrack, "Smithing")
		ForcePageReset()
	;Sneak
	ElseIf (option == PerkID[30])
		AddPerksFunc(SneakPerks, SneakPerksTrack, "Sneak")
		ForcePageReset()
	ElseIf (option == PerkID[31])
		RemovePerksFunc(SneakPerks, SneakPerksTrack, "Sneak")
		ForcePageReset()
	;Speech
	ElseIf (option == PerkID[32])
		AddPerksFunc(SpeechPerks, SpeechPerksTrack, "Speech")
		ForcePageReset()
	ElseIf (option == PerkID[33])
		RemovePerksFunc(SpeechPerks, SpeechPerksTrack, "Speech")
		ForcePageReset()
	;Two Handed
	ElseIf (option == PerkID[34])
		AddPerksFunc(TwoHandedPerks, TwoHandedPerksTrack, "TwoHanded")
		ForcePageReset()
	ElseIf (option == PerkID[35])
		RemovePerksFunc(TwoHandedPerks, TwoHandedPerksTrack, "TwoHanded")
		ForcePageReset()
	EndIf
	
	;Alchemy perk toggles
	If (option == AlchemyPerksID[0])
		Int index = 0
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[1])
		Int index = 1
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[2])
		Int index = 2
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[3])
		Int index = 3
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[4])
		Int index = 4
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[5])
		Int index = 5
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[6])
		Int index = 6
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[7])
		Int index = 7
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[8])
		Int index = 8
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[9])
		Int index = 9
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[10])
		Int index = 10
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[11])
		Int index = 11
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[12])
		Int index = 12
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[13])
		Int index = 13
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	ElseIf (option == AlchemyPerksID[14])
		Int index = 14
		AddRemovePerkFunc(AlchemyPerks, AlchemyPerksTrack, AlchemyPerksState, index)
		AlchemyPerksState[index] = !AlchemyPerksState[index]
		SetToggleOptionValue(AlchemyPerksID[index], AlchemyPerksState[index])
	EndIf

	;Alteration perk toggles
	If (option == AlterationPerksID[0])
		Int index = 0
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[1])
		Int index = 1
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[2])
		Int index = 2
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[3])
		Int index = 3
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[4])
		Int index = 4
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[5])
		Int index = 5
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[6])
		Int index = 6
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[7])
		Int index = 7
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[8])
		Int index = 8
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[9])
		Int index = 9
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[10])
		Int index = 10
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[11])
		Int index = 11
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[12])
		Int index = 12
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	ElseIf (option == AlterationPerksID[13])
		Int index = 13
		AddRemovePerkFunc(AlterationPerks, AlterationPerksTrack, AlterationPerksState, index)
		AlterationPerksState[index] = !AlterationPerksState[index]
		SetToggleOptionValue(AlterationPerksID[index], AlterationPerksState[index])
	EndIf
	
	;Archery perk toggles
	If (option == ArcheryPerksID[0])
		Int index = 0
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[1])
		Int index = 1
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[2])
		Int index = 2
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[3])
		Int index = 3
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[4])
		Int index = 4
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[5])
		Int index = 5
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[6])
		Int index = 6
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[7])
		Int index = 7
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[8])
		Int index = 8
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[9])
		Int index = 9
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[10])
		Int index = 10
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[11])
		Int index = 11
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[12])
		Int index = 12
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[13])
		Int index = 13
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[14])
		Int index = 14
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	ElseIf (option == ArcheryPerksID[15])
		Int index = 15
		AddRemovePerkFunc(ArcheryPerks, ArcheryPerksTrack, ArcheryPerksState, index)
		ArcheryPerksState[index] = !ArcheryPerksState[index]
		SetToggleOptionValue(ArcheryPerksID[index], ArcheryPerksState[index])
	EndIf
	
	;Block perk toggles
	If (option == BlockPerksID[0])
		Int index = 0
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[1])
		Int index = 1
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[2])
		Int index = 2
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[3])
		Int index = 3
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[4])
		Int index = 4
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[5])
		Int index = 5
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[6])
		Int index = 6
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[7])
		Int index = 7
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[8])
		Int index = 8
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[9])
		Int index = 9
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[10])
		Int index = 10
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[11])
		Int index = 11
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	ElseIf (option == BlockPerksID[12])
		Int index = 12
		AddRemovePerkFunc(BlockPerks, BlockPerksTrack, BlockPerksState, index)
		BlockPerksState[index] = !BlockPerksState[index]
		SetToggleOptionValue(BlockPerksID[index], BlockPerksState[index])
	EndIf
	
	;Conjuration perk toggles
	If (option == ConjurationPerksID[0])
		Int index = 0
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[1])
		Int index = 1
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[2])
		Int index = 2
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[3])
		Int index = 3
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[4])
		Int index = 4
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[5])
		Int index = 5
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[6])
		Int index = 6
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[7])
		Int index = 7
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[8])
		Int index = 8
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[9])
		Int index = 9
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[10])
		Int index = 10
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[11])
		Int index = 11
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[12])
		Int index = 12
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[13])
		Int index = 13
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[14])
		Int index = 14
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	ElseIf (option == ConjurationPerksID[15])
		Int index = 15
		AddRemovePerkFunc(ConjurationPerks, ConjurationPerksTrack, ConjurationPerksState, index)
		ConjurationPerksState[index] = !ConjurationPerksState[index]
		SetToggleOptionValue(ConjurationPerksID[index], ConjurationPerksState[index])
	EndIf
	
	;Destruction perk toggles
	If (option == DestructionPerksID[0])
		Int index = 0
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[1])
		Int index = 1
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[2])
		Int index = 2
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[3])
		Int index = 3
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[4])
		Int index = 4
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[5])
		Int index = 5
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[6])
		Int index = 6
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[7])
		Int index = 7
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[8])
		Int index = 8
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[9])
		Int index = 9
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[10])
		Int index = 10
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[11])
		Int index = 11
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[12])
		Int index = 12
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[13])
		Int index = 13
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[14])
		Int index = 14
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[15])
		Int index = 15
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	ElseIf (option == DestructionPerksID[16])
		Int index = 16
		AddRemovePerkFunc(DestructionPerks, DestructionPerksTrack, DestructionPerksState, index)
		DestructionPerksState[index] = !DestructionPerksState[index]
		SetToggleOptionValue(DestructionPerksID[index], DestructionPerksState[index])
	EndIf
	
	;Enchanting perk toggles
	If (option == EnchantingPerksID[0])
		Int index = 0
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[1])
		Int index = 1
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[2])
		Int index = 2
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[3])
		Int index = 3
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[4])
		Int index = 4
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[5])
		Int index = 5
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[6])
		Int index = 6
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[7])
		Int index = 7
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[8])
		Int index = 8
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[9])
		Int index = 9
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[10])
		Int index = 10
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[11])
		Int index = 11
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	ElseIf (option == EnchantingPerksID[12])
		Int index = 12
		AddRemovePerkFunc(EnchantingPerks, EnchantingPerksTrack, EnchantingPerksState, index)
		EnchantingPerksState[index] = !EnchantingPerksState[index]
		SetToggleOptionValue(EnchantingPerksID[index], EnchantingPerksState[index])
	EndIf
	
	;Heavy Armor perk toggles
	If (option == HeavyArmorPerksID[0])
		Int index = 0
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[1])
		Int index = 1
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[2])
		Int index = 2
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[3])
		Int index = 3
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[4])
		Int index = 4
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[5])
		Int index = 5
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[6])
		Int index = 6
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[7])
		Int index = 7
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[8])
		Int index = 8
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[9])
		Int index = 9
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[10])
		Int index = 10
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	ElseIf (option == HeavyArmorPerksID[11])
		Int index = 11
		AddRemovePerkFunc(HeavyArmorPerks, HeavyArmorPerksTrack, HeavyArmorPerksState, index)
		HeavyArmorPerksState[index] = !HeavyArmorPerksState[index]
		SetToggleOptionValue(HeavyArmorPerksID[index], HeavyArmorPerksState[index])
	EndIf
	
	;Illusion perk toggles
	If (option == IllusionPerksID[0])
		Int index = 0
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[1])
		Int index = 1
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[2])
		Int index = 2
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[3])
		Int index = 3
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[4])
		Int index = 4
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[5])
		Int index = 5
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[6])
		Int index = 6
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[7])
		Int index = 7
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[8])
		Int index = 8
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[9])
		Int index = 9
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[10])
		Int index = 10
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[11])
		Int index = 11
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	ElseIf (option == IllusionPerksID[12])
		Int index = 12
		AddRemovePerkFunc(IllusionPerks, IllusionPerksTrack, IllusionPerksState, index)
		IllusionPerksState[index] = !IllusionPerksState[index]
		SetToggleOptionValue(IllusionPerksID[index], IllusionPerksState[index])
	EndIf
	
	;Light Armor perk toggles
	If (option == LightArmorPerksID[0])
		Int index = 0
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[1])
		Int index = 1
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[2])
		Int index = 2
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[3])
		Int index = 3
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[4])
		Int index = 4
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[5])
		Int index = 5
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[6])
		Int index = 6
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[7])
		Int index = 7
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[8])
		Int index = 8
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	ElseIf (option == LightArmorPerksID[9])
		Int index = 9
		AddRemovePerkFunc(LightArmorPerks, LightArmorPerksTrack, LightArmorPerksState, index)
		LightArmorPerksState[index] = !LightArmorPerksState[index]
		SetToggleOptionValue(LightArmorPerksID[index], LightArmorPerksState[index])
	EndIf
	
	;Lockpicking perk toggles
	If (option == LockpickingPerksID[0])
		Int index = 0
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[1])
		Int index = 1
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[2])
		Int index = 2
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[3])
		Int index = 3
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[4])
		Int index = 4
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[5])
		Int index = 5
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[6])
		Int index = 6
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[7])
		Int index = 7
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[8])
		Int index = 8
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[9])
		Int index = 9
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	ElseIf (option == LockpickingPerksID[10])
		Int index = 10
		AddRemovePerkFunc(LockpickingPerks, LockpickingPerksTrack, LockpickingPerksState, index)
		LockpickingPerksState[index] = !LockpickingPerksState[index]
		SetToggleOptionValue(LockpickingPerksID[index], LockpickingPerksState[index])
	EndIf
	
	;One Handed perk toggles
	If (option == OneHandedPerksID[0])
		Int index = 0
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[1])
		Int index = 1
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[2])
		Int index = 2
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[3])
		Int index = 3
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[4])
		Int index = 4
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[5])
		Int index = 5
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[6])
		Int index = 6
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[7])
		Int index = 7
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[8])
		Int index = 8
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[9])
		Int index = 9
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[10])
		Int index = 10
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[11])
		Int index = 11
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[12])
		Int index = 12
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[13])
		Int index = 13
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[14])
		Int index = 14
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[15])
		Int index = 15
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[16])
		Int index = 16
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[17])
		Int index = 17
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[18])
		Int index = 18
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[19])
		Int index = 19
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	ElseIf (option == OneHandedPerksID[20])
		Int index = 20
		AddRemovePerkFunc(OneHandedPerks, OneHandedPerksTrack, OneHandedPerksState, index)
		OneHandedPerksState[index] = !OneHandedPerksState[index]
		SetToggleOptionValue(OneHandedPerksID[index], OneHandedPerksState[index])
	EndIf
	
	;Pickpocket perk toggles
	If (option == PickpocketPerksID[0])
		Int index = 0
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[1])
		Int index = 1
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[2])
		Int index = 2
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[3])
		Int index = 3
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[4])
		Int index = 4
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[5])
		Int index = 5
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[6])
		Int index = 6
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[7])
		Int index = 7
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[8])
		Int index = 8
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[9])
		Int index = 9
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[10])
		Int index = 10
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	ElseIf (option == PickpocketPerksID[11])
		Int index = 11
		AddRemovePerkFunc(PickpocketPerks, PickpocketPerksTrack, PickpocketPerksState, index)
		PickpocketPerksState[index] = !PickpocketPerksState[index]
		SetToggleOptionValue(PickpocketPerksID[index], PickpocketPerksState[index])
	EndIf
	
	;Restoration perk toggles
	If (option == RestorationPerksID[0])
		Int index = 0
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[1])
		Int index = 1
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[2])
		Int index = 2
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[3])
		Int index = 3
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[4])
		Int index = 4
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[5])
		Int index = 5
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[6])
		Int index = 6
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[7])
		Int index = 7
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[8])
		Int index = 8
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[9])
		Int index = 9
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[10])
		Int index = 10
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[11])
		Int index = 11
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	ElseIf (option == RestorationPerksID[12])
		Int index = 12
		AddRemovePerkFunc(RestorationPerks, RestorationPerksTrack, RestorationPerksState, index)
		RestorationPerksState[index] = !RestorationPerksState[index]
		SetToggleOptionValue(RestorationPerksID[index], RestorationPerksState[index])
	EndIf
	
	;Smithing perk toggles
	If (option == SmithingPerksID[0])
		Int index = 0
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[1])
		Int index = 1
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[2])
		Int index = 2
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[3])
		Int index = 3
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[4])
		Int index = 4
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[5])
		Int index = 5
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[6])
		Int index = 6
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[7])
		Int index = 7
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[8])
		Int index = 8
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	ElseIf (option == SmithingPerksID[9])
		Int index = 9
		AddRemovePerkFunc(SmithingPerks, SmithingPerksTrack, SmithingPerksState, index)
		SmithingPerksState[index] = !SmithingPerksState[index]
		SetToggleOptionValue(SmithingPerksID[index], SmithingPerksState[index])
	EndIf
	
	;Sneak perk toggles
	If (option == SneakPerksID[0])
		Int index = 0
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[1])
		Int index = 1
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[2])
		Int index = 2
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[3])
		Int index = 3
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[4])
		Int index = 4
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[5])
		Int index = 5
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[6])
		Int index = 6
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[7])
		Int index = 7
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[8])
		Int index = 8
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[9])
		Int index = 9
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[10])
		Int index = 10
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[11])
		Int index = 11
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	ElseIf (option == SneakPerksID[12])
		Int index = 12
		AddRemovePerkFunc(SneakPerks, SneakPerksTrack, SneakPerksState, index)
		SneakPerksState[index] = !SneakPerksState[index]
		SetToggleOptionValue(SneakPerksID[index], SneakPerksState[index])
	EndIf
	
	;Speech perk toggles
	If (option == SpeechPerksID[0])
		Int index = 0
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[1])
		Int index = 1
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[2])
		Int index = 2
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[3])
		Int index = 3
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[4])
		Int index = 4
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[5])
		Int index = 5
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[6])
		Int index = 6
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[7])
		Int index = 7
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[8])
		Int index = 8
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[9])
		Int index = 9
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[10])
		Int index = 10
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[11])
		Int index = 11
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	ElseIf (option == SpeechPerksID[12])
		Int index = 12
		AddRemovePerkFunc(SpeechPerks, SpeechPerksTrack, SpeechPerksState, index)
		SpeechPerksState[index] = !SpeechPerksState[index]
		SetToggleOptionValue(SpeechPerksID[index], SpeechPerksState[index])
	EndIf
	
	;Two Handed perk toggles
	If (option == TwoHandedPerksID[0])
		Int index = 0
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[1])
		Int index = 1
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[2])
		Int index = 2
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[3])
		Int index = 3
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[4])
		Int index = 4
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[5])
		Int index = 5
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[6])
		Int index = 6
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[7])
		Int index = 7
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[8])
		Int index = 8
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[9])
		Int index = 9
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[10])
		Int index = 10
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[11])
		Int index = 11
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[12])
		Int index = 12
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[13])
		Int index = 13
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[14])
		Int index = 14
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[15])
		Int index = 15
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[16])
		Int index = 16
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[17])
		Int index = 17
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	ElseIf (option == TwoHandedPerksID[18])
		Int index = 18
		AddRemovePerkFunc(TwoHandedPerks, TwoHandedPerksTrack, TwoHandedPerksState, index)
		TwoHandedPerksState[index] = !TwoHandedPerksState[index]
		SetToggleOptionValue(TwoHandedPerksID[index], TwoHandedPerksState[index])
	EndIf
	
EndEvent

Event OnOptionSliderOpen(Int option)
	;Set the slider options/settings when a slider dialogue is opened

	If (option == HealthID)
		SetSliderDialogStartValue(HealthState)
		SetSliderDialogDefaultValue(HealthDef)
		SetSliderDialogRange(10, 1000)
		SetSliderDialogInterval(10)
	ElseIf (option == StaminaID)
		SetSliderDialogStartValue(StaminaState)
		SetSliderDialogDefaultValue(StaminaDef)
		SetSliderDialogRange(10, 1000)
		SetSliderDialogInterval(10)
	ElseIf (option == MagickaID)
		SetSliderDialogStartValue(MagickaState)
		SetSliderDialogDefaultValue(MagickaDef)
		SetSliderDialogRange(10, 1000)
		SetSliderDialogInterval(10)
	ElseIf (option == HealRateID)
		SetSliderDialogStartValue(HealRateState)
		SetSliderDialogDefaultValue(HealRateDef)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(0.1)
	ElseIf (option == StaminaRateID)
		SetSliderDialogStartValue(StaminaRateState)
		SetSliderDialogDefaultValue(StaminaRateDef)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(0.1)
	ElseIf (option == MagickaRateID)
		SetSliderDialogStartValue(MagickaRateState)
		SetSliderDialogDefaultValue(MagickaRateDef)
		SetSliderDialogRange(0, 25)
		SetSliderDialogInterval(0.1)
	ElseIf (option == SpeedMultID)
		SetSliderDialogStartValue(SpeedMultState)
		SetSliderDialogDefaultValue(SpeedMultDef)
		SetSliderDialogRange(0, 400)
		SetSliderDialogInterval(5)
	ElseIf (option == WeaponSpeedmultID)
		SetSliderDialogStartValue(WeaponSpeedMultState)
		SetSliderDialogDefaultValue(WeaponSpeedMultDef)
		SetSliderDialogRange(0, 4)
		SetSliderDialogInterval(0.25)
	ElseIf (option == WeaponLeftSpeedMultID)
		SetSliderDialogStartValue(WeaponLeftSpeedMultState)
		SetSliderDialogDefaultValue(WeaponLeftSpeedMultDef)
		SetSliderDialogRange(0, 4)
		SetSliderDialogInterval(0.25)
	ElseIf (option == ShoutRecoveryMultID)
		SetSliderDialogStartValue(ShoutRecoveryMultState)
		SetSliderDialogDefaultValue(ShoutRecoveryMultDef)
		SetSliderDialogRange(0, 5)
		SetSliderDialogInterval(0.1)
	ElseIf (option == MagicResistID)
		SetSliderDialogStartValue(MagicResistState)
		SetSliderDialogDefaultValue(MagicResistDef)
		SetSliderDialogRange(-100, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == CritChanceID)
		SetSliderDialogStartValue(CritChanceState)
		SetSliderDialogDefaultValue(CritChanceDef)
		SetSliderDialogRange(0, 2000)
		SetSliderDialogInterval(10)
	ElseIf (option == FrostResistID)
		SetSliderDialogStartValue(FrostResistState)
		SetSliderDialogDefaultValue(FrostResistDef)
		SetSliderDialogRange(-100, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == FireResistID)
		SetSliderDialogStartValue(FireResistState)
		SetSliderDialogDefaultValue(FireResistDef)
		SetSliderDialogRange(-100, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == ShockResistID)
		SetSliderDialogStartValue(ShockResistState)
		SetSliderDialogDefaultValue(ShockResistDef)
		SetSliderDialogRange(-100, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == PoisonResistID)
		SetSliderDialogStartValue(PoisonResistState)
		SetSliderDialogDefaultValue(PoisonResistDef)
		SetSliderDialogRange(-100, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == DiseaseResistID)
		SetSliderDialogStartValue(DiseaseResistState)
		SetSliderDialogDefaultValue(DiseaseResistDef)
		SetSliderDialogRange(-100, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == UnarmedDamageID)
		SetSliderDialogStartValue(UnarmedDamageState)
		SetSliderDialogDefaultValue(UnarmedDamageDef)
		SetSliderDialogRange(0, 100)
		SetSliderDialogInterval(1)
	ElseIf (option == CarryWeightID)
		SetSliderDialogStartValue(CarryWeightState)
		SetSliderDialogDefaultValue(CarryWeightDef)
		SetSliderDialogRange(0, 1000)
		SetSliderDialogInterval(5)
	EndIf
EndEvent

Event OnOptionSliderAccept(int option, float value)
	;Define the actions to take when a slider dialogue is closed with an 'accept'

	If (option == HealthID)
		HealthState = value
		Log("Setting player health to " + value as String)
		PlayerRef.SetActorValue("health", value)
		SetSliderOptionValue(HealthID, value, "{0}")
	ElseIf (option == StaminaID)
		StaminaState = value
		Log("Setting player stamina to " + value as String)
		PlayerRef.SetActorValue("stamina", value)
		SetSliderOptionValue(StaminaID, value, "{0}")
	ElseIf (option == MagickaID)
		MagickaState = value
		Log("Setting player magicka to " + value as String)
		PlayerRef.SetActorValue("magicka", value)
		SetSliderOptionValue(MagickaID, value, "{0}")
	ElseIf (option == HealRateID)
		HealRateState = value
		Log("Setting player healrate to " + value as String)
		PlayerRef.ForceActorValue("healrate", value)
		SetSliderOptionValue(HealRateID, value, "{1}")
	ElseIf (option == StaminaRateID)
		StaminaRateState = value
		Log("Setting player staminarate to " + value as String)
		PlayerRef.ForceActorValue("staminarate", value)
		SetSliderOptionValue(StaminaRateID, value, "{1}")
	ElseIf (option == MagickaRateID)
		MagickaRateState = value
		Log("Setting player magickarate to " + value as String)
		PlayerRef.ForceActorValue("magickarate", value)
		SetSliderOptionValue(MagickaRateID, value, "{1}")
	ElseIf (option == SpeedMultID)
		SpeedMultState = value
		Log("Setting player speedmult to " + value as String)
		PlayerRef.SetActorValue("speedmult", value)
		SetSliderOptionValue(SpeedMultID, value, "{0}")
	ElseIf (option == WeaponSpeedMultID)
		WeaponSpeedMultState = value
		Log("Setting player weaponspeedmult to " + value as String)
		PlayerRef.SetActorValue("weaponspeedmult", value)
		SetSliderOptionValue(WeaponSpeedMultID, value, "{2}")
	ElseIf (option == WeaponLeftSpeedMultID)
		WeaponLeftSpeedMultState = value
		Log("Setting player leftweaponspeedmult to " + value as String)
		PlayerRef.SetActorValue("leftweaponspeedmult", value)
		SetSliderOptionValue(WeaponLeftSpeedMultID, value, "{2}")
	ElseIf (option == MagicResistID)
		MagicResistState = value
		Log("Setting player magicresist to " + value as String)
		PlayerRef.SetActorValue("magicresist", value)
		SetSliderOptionValue(MagicResistID, value, "{0}")
	ElseIf (option == ShoutRecoveryMultID)
		ShoutRecoveryMultState = value
		Log("Setting player shoutrecoverymult to " + value as String)
		PlayerRef.SetActorValue("shoutrecoverymult", value)
		SetSliderOptionValue(ShoutRecoveryMultID, value, "{1}")
	ElseIf (option == CritChanceID)
		CritChanceState = value
		Log("Setting player critchance to " + value as String)
		PlayerRef.SetActorValue("critchance", value)
		SetSliderOptionValue(CritChanceID, value, "{0}")
	ElseIf (option == CarryWeightID)
		CarryWeightState = value
		Log("Setting player carry weight to " + value as String)
		PlayerRef.ForceActorValue("carryweight", value)
		SetSliderOptionValue(CarryWeightID, value, "{0}")
	ElseIf (option == FireResistID)
		FireResistState = value
		Log("Setting player fireresist to " + value as String)
		PlayerRef.SetActorValue("fireresist", value)
		SetSliderOptionValue(FireResistID, value, "{0}")
	ElseIf (option == FrostResistID)
		FrostResistState = value
		Log("Setting player frostresist to " + value as String)
		PlayerRef.SetActorValue("frostresist", value)
		SetSliderOptionValue(FrostResistID, value, "{0}")
	ElseIf (option == ShockResistID)
		ShockResistState = value
		Log("Setting player electricresist to " + value as String)
		PlayerRef.SetActorValue("electricresist", value)
		SetSliderOptionValue(ShockResistID, value, "{0}")
	ElseIf (option == PoisonResistID)
		PoisonResistState = value
		Log("Setting player poisonresist to " + value as String)
		PlayerRef.SetActorValue("poisonresist", value)
		SetSliderOptionValue(PoisonResistID, value, "{0}")
	ElseIf (option == DiseaseResistID)
		DiseaseResistState = value
		Log("Setting player diseaseresist to " + value as String)
		PlayerRef.SetActorValue("diseaseresist", value)
		SetSliderOptionValue(DiseaseResistID, value, "{0}")
	ElseIf (option == UnarmedDamageID)
		UnarmedDamageState = value
		Log("Setting player unarmeddamage to " + value as String)
		PlayerRef.SetActorValue("unarmeddamage", value)
		SetSliderOptionValue(UnarmedDamageID, value, "{0}")
	EndIf
EndEvent

Event OnOptionHighlight(Int option)
	;Sets the "tooltip" text to display when an option is moused over
	
	;Perk tracking toggles
	If (option == TrackID[0] || option == TrackID[1] || option == TrackID[2] || option == TrackID[3] || option == TrackID[4] || option == TrackID[5] || option == TrackID[6] || option == TrackID[7] || option == TrackID[8] || option == TrackID[9] || option == TrackID[10] || option == TrackID[11] || option == TrackID[12] || option == TrackID[13] || option == TrackID[14] || option == TrackID[15] || option == TrackID[16] || option == TrackID[17] || option == TrackID[18])
		SetInfoText("Enable/Disable Perk Tracking\nWhile tracking the 'Disable All X Perks' will only remove perks added by SCP.")
	EndIf
	
	;General Page
	If (option == SaveOneID || option == SaveTwoID || option == SaveThreeID)
		SetInfoText("Save your SCP settings.\nSave files located in Skyrim/Data/SCP_Saves/\nWarning: Can be slow, please be patient.")
	ElseIf (option == LoadOneID || option == LoadTwoID || option == LoadThreeID)
		SetInfoText("Load your previously saved SCP settings.\nWarning: Can be slow, please be patient.")
	EndIf

	;Stats page
	If (option == HealthID)
		SetInfoText("Set player max health.\nDEFAULT: 100 at level 1")
	ElseIf (option == StaminaID)
		SetInfoText("Set player max stamina.\nDEFAULT: 100 at level 1")
	ElseIf (option == MagickaID)
		SetInfoText("Set player max magicka.\nDEFAULT: 100 at level 1")
	ElseIf (option == HealRateID)
		SetInfoText("Set player health regen rate.\nDEFAULT: 0.7 (% max HP/sec)")
	ElseIf (option == StaminaRateID)
		SetInfoText("Set player stamina regen rate.\nDEFAULT: 5.0 (% max Stam/sec)")
	ElseIf (option == MagickaRateID)
		SetInfoText("Set player magicka regen rate.\nDEFAULT: 3.0 (% max Mag/sec)")
	ElseIf (option == SpeedMultID)
		SetInfoText("Player movement speed multiplier.\nDEFAULT: 100")
	ElseIf (option == WeaponSpeedMultID)
		SetInfoText("One/Two-handed weapon speed multiplier.\n1 is normal speed, 0 is no multiplier (same speed as 1)\nDEFAULT: 0")
	ElseIf (option == WeaponLeftSpeedMultID)
		SetInfoText("Left hand weapon speed multiplier.\n1 is normal speed, 0 is no multiplier (same speed as 1)\nDEFAULT: 0")
	ElseIf (option == MagicResistID)
		SetInfoText("Player base magic resist.\nDEFAULT: " + MagicResistDef as String)
	ElseIf (option == ShoutRecoveryMultID)
		SetInfoText("Player shout cooldown multiplier.\n0 is no cooldown between shouts.\nDEFAULT: 1")
	ElseIf (option == CritChanceID)
		SetInfoText("Has something to do with crit chance. Higher values means more likely to crit.\nUnsure of function beyond that.\nDEFAULT: 0")
	ElseIf (option == CarryWeightID)
		SetInfoText("Player carry weight.\nDEFAULT: 300 plus 5 for every Stamina level up (5:10)")
	ElseIf (option == FrostResistID)
		SetInfoText("Player frost resist.\nDEFAULT: " + FrostResistDef as String)
	ElseIf (option == FireResistID)
		SetInfoText("Player fire resist.\nDEFAULT: " + FireResistDef as String)
	ElseIf (option == ShockResistID)
		SetInfoText("Player shock resist.\nDEFAULT: " + ShockResistDef as String)	
	ElseIf (option == PoisonResistID)
		SetInfoText("Player poison resist.\nDEFAULT: " + PoisonResistDef as String)
	ElseIf (option == DiseaseResistID)
		SetInfoText("Player disease resist.\nDEFAULT: " + DiseaseResistDef as String)
	ElseIf (option == UnarmedDamageID)
		SetInfoText("Player unarmed damage.\nDEFAULT: " + UnarmedDamageDef as String)
	EndIf

	;Alchemy page
	If (option == AlchemyPerksID[0])
		SetInfoText("Potions and poisons you make are 20% stronger.")
	ElseIf (option == AlchemyPerksID[1])
		SetInfoText("Potions and poisons you make are 40% stronger.")
	ElseIf (option == AlchemyPerksID[2])
		SetInfoText("Potions and poisons you make are 60% stronger.")
	ElseIf (option == AlchemyPerksID[3])
		SetInfoText("Potions and poisons you make are 80% stronger.")
	ElseIf (option == AlchemyPerksID[4])
		SetInfoText("Potions and poisons you make are twice as strong.")
	ElseIf (option == AlchemyPerksID[5])
		SetInfoText("Potions you mix that restore Health, Magicka or Stamina are 25% more powerful.")
	ElseIf (option == AlchemyPerksID[6])
		SetInfoText("Potions you mix with beneficial effects have an additional 25% greater magnitude.")
	ElseIf (option == AlchemyPerksID[7])
		SetInfoText("Poisons you mix are 25% more effective.")
	ElseIf (option == AlchemyPerksID[8])
		SetInfoText("Eating an ingredient reveals first two effects.")
	ElseIf (option == AlchemyPerksID[9])
		SetInfoText("Eating an ingredient reveals first three effects.")
	ElseIf (option == AlchemyPerksID[10])
		SetInfoText("Eating an ingredient reveals all its effects.")
	ElseIf (option == AlchemyPerksID[11])
		SetInfoText("Poisons applied to weapons last for twice as many hits.")
	ElseIf (option == AlchemyPerksID[12])
		SetInfoText("Two ingredients are gathered from plants.")
	ElseIf (option == AlchemyPerksID[13])
		SetInfoText("50% resistance to all poisons.")
	ElseIf (option == AlchemyPerksID[14])
		SetInfoText("All negative effects are removed from created potions, and all positive effects are removed from created poisons.")
	EndIf
	
	;Alteration page
	If (option == AlterationPerksID[0])
		SetInfoText("Cast Novice level Alteration spells for half magicka.")
	ElseIf (option == AlterationPerksID[1])
		SetInfoText("Dual casting an Alteration spell overcharges the effects into an even more powerful version.")
	ElseIf (option == AlterationPerksID[2])
		SetInfoText("Cast Apprentice level Alteration spells for half magicka.")
	ElseIf (option == AlterationPerksID[3])
		SetInfoText("Protection spells like Stoneflesh are twice as strong if not wearing armor.")
	ElseIf (option == AlterationPerksID[4])
		SetInfoText("Protection spells like Stoneflesh are 2.5 times as strong if not wearing armor.")
	ElseIf (option == AlterationPerksID[5])
		SetInfoText("Protection spells like Stoneflesh are three times as strong if not wearing armor.")
	ElseIf (option == AlterationPerksID[6])
		SetInfoText("Blocks 10% of a spell's effects.")
	ElseIf (option == AlterationPerksID[7])
		SetInfoText("Blocks 20% of a spell's effects.")
	ElseIf (option == AlterationPerksID[8])
		SetInfoText("Blocks 30% of a spell's effects.")
	ElseIf (option == AlterationPerksID[9])
		SetInfoText("Cast Adept level Alteration spells for half magicka.")
	ElseIf (option == AlterationPerksID[10])
		SetInfoText("Alteration spells have 50% greater duration.")
	ElseIf (option == AlterationPerksID[11])
		SetInfoText("Cast Expert level Alteration spells for half magicka.")
	ElseIf (option == AlterationPerksID[12])
		SetInfoText("Absorb 30% of the magicka of any spells that hit you.")
	ElseIf (option == AlterationPerksID[13])
		SetInfoText("Cast Master level Alteration spells for half magicka.")
	EndIf
	
	;Archery page
	If (option == ArcheryPerksID[0])
		SetInfoText("Bows do 20% more damage.")
	ElseIf (option == ArcheryPerksID[1])
		SetInfoText("Bows do 40% more damage.")
	ElseIf (option == ArcheryPerksID[2])
		SetInfoText("Bows do 60% more damage.")
	ElseIf (option == ArcheryPerksID[3])
		SetInfoText("Bows do 80% more damage.")
	ElseIf (option == ArcheryPerksID[4])
		SetInfoText("Bows always do twice as much damage.")
	ElseIf (option == ArcheryPerksID[5])
		SetInfoText("10% chance of a critical hit that does extra damage.")
	ElseIf (option == ArcheryPerksID[6])
		SetInfoText("15% chance of a critical hit that does 25% more critical damage.")
	ElseIf (option == ArcheryPerksID[7])
		SetInfoText("20% chance of a critical hit that does 50% more critical damage.")
	ElseIf (option == ArcheryPerksID[8])
		SetInfoText("Pressing Block while aiming will zoom in your view.")
	ElseIf (option == ArcheryPerksID[9])
		SetInfoText("Zooming in with a bow slows time by 25%.")
	ElseIf (option == ArcheryPerksID[10])
		SetInfoText("Zooming in with a bow slows time by 50%.")
	ElseIf (option == ArcheryPerksID[11])
		SetInfoText("Recover twice as many arrows from dead bodies.")
	ElseIf (option == ArcheryPerksID[12])
		SetInfoText("Arrows stagger all but the largest opponents 50% of the time.")
	ElseIf (option == ArcheryPerksID[13])
		SetInfoText("Able to move faster with a drawn bow.")
	ElseIf (option == ArcheryPerksID[14])
		SetInfoText("Can draw a bow 30% faster.")
	ElseIf (option == ArcheryPerksID[15])
		SetInfoText("15% chance of paralyzing the target for a few seconds.")
	EndIf
	
	;Block page
	If (option == BlockPerksID[0])
		SetInfoText("Blocking is 20% more effective.")
	ElseIf (option == BlockPerksID[1])
		SetInfoText("Blocking is 25% more effective.")
	ElseIf (option == BlockPerksID[2])
		SetInfoText("Blocking is 30% more effective.")
	ElseIf (option == BlockPerksID[3])
		SetInfoText("Blocking is 35% more effective.")
	ElseIf (option == BlockPerksID[4])
		SetInfoText("Blocking is 40% more effective.")
	ElseIf (option == BlockPerksID[5])
		SetInfoText("Arrows that hit the shield do no damage.")
	ElseIf (option == BlockPerksID[6])
		SetInfoText("Able to do a power bash.")
	ElseIf (option == BlockPerksID[7])
		SetInfoText("Time slows down if you are blocking during an enemy's power attack.")
	ElseIf (option == BlockPerksID[8])
		SetInfoText("Bashing does five times more damage.")
	ElseIf (option == BlockPerksID[9])
		SetInfoText("Blocking with a shield reduces incoming fire, frost, and shock damage by 50%.")
	ElseIf (option == BlockPerksID[10])
		SetInfoText("Able to move faster with a shield or weapon raised.")
	ElseIf (option == BlockPerksID[11])
		SetInfoText("Chance to disarm when power bashing.")
	ElseIf (option == BlockPerksID[12])
		SetInfoText("Sprinting with a shield raised knocks down most targets.")
	EndIf
	
	;Conjuration page
	If (option == ConjurationPerksID[0])
		SetInfoText("Cast Novice level Conjuration spells for half magicka.")
	ElseIf (option == ConjurationPerksID[1])
		SetInfoText("Dual casting a Conjuration spell overcharges the spell, allowing it to last longer.")
	ElseIf (option == ConjurationPerksID[2])
		SetInfoText("Bound weapons do more damage.")
	ElseIf (option == ConjurationPerksID[3])
		SetInfoText("Cast Apprentice level Conjuration spells for half magicka.")
	ElseIf (option == ConjurationPerksID[4])
		SetInfoText("Bound weapons cast Soul Trap on targets.")
	ElseIf (option == ConjurationPerksID[5])
		SetInfoText("Can summon atronachs or raise undead twice as far away.")
	ElseIf (option == ConjurationPerksID[6])
		SetInfoText("Can summon atronachs or raise undead three times as far away.")
	ElseIf (option == ConjurationPerksID[7])
		SetInfoText("Double duration for conjured Atronachs.")
	ElseIf (option == ConjurationPerksID[8])
		SetInfoText("Greater duration for reanimated undead.")
	ElseIf (option == ConjurationPerksID[9])
		SetInfoText("Cast Adept level Conjuration spells for half magicka.")
	ElseIf (option == ConjurationPerksID[10])
		SetInfoText("Bound weapons will banish summoned creatures and turn raised ones. 	")
	ElseIf (option == ConjurationPerksID[11])
		SetInfoText("Reanimated undead have 100 points more health.")
	ElseIf (option == ConjurationPerksID[12])
		SetInfoText("Cast Expert level Conjuration spells for half magicka.")
	ElseIf (option == ConjurationPerksID[13])
		SetInfoText("Conjured Atronachs are 50% more powerful.")
	ElseIf (option == ConjurationPerksID[14])
		SetInfoText("Cast Master level Conjuration spells for half magicka.")
	ElseIf (option == ConjurationPerksID[15])
		SetInfoText("You can have two atronachs or reanimated zombies.")
	EndIf
	
	;Destruction page
	If (option == DestructionPerksID[0])
		SetInfoText("Cast Novice level Destruction spells for half magicka.")
	ElseIf (option == DestructionPerksID[1])
		SetInfoText("Dual casting a Destruction spell overcharges the effects into an even more powerful version.")
	ElseIf (option == DestructionPerksID[2])
		SetInfoText("Cast Apprentice level Destruction spells for half magicka.")
	ElseIf (option == DestructionPerksID[3])
		SetInfoText("Fire spells do 25% more damage.")
	ElseIf (option == DestructionPerksID[4])
		SetInfoText("Fire spells do 50% more damage.")
	ElseIf (option == DestructionPerksID[5])
		SetInfoText("Frost spells do 25% more damage.")
	ElseIf (option == DestructionPerksID[6])
		SetInfoText("Frost spells do 50% more damage.")
	ElseIf (option == DestructionPerksID[7])
		SetInfoText("Shock spells do 25% more damage.")
	ElseIf (option == DestructionPerksID[8])
		SetInfoText("Shock spells do 50% more damage.")
	ElseIf (option == DestructionPerksID[9])
		SetInfoText("Most destruction spells will stagger an opponent when dual cast.")
	ElseIf (option == DestructionPerksID[10])
		SetInfoText("Can place runes five times farther away.")
	ElseIf (option == DestructionPerksID[11])
		SetInfoText("Cast Adept level Destruction spells for half magicka.")
	ElseIf (option == DestructionPerksID[12])
		SetInfoText("Fire damage causes targets to flee if their health is low (under 20%).")
	ElseIf (option == DestructionPerksID[13])
		SetInfoText("Frost damage paralyzes targets if their health is low (under 20%).")
	ElseIf (option == DestructionPerksID[14])
		SetInfoText("Shock spells disintegrate targets if their health is low (under 15%).")
	ElseIf (option == DestructionPerksID[15])
		SetInfoText("Cast Expert level Destruction spells for half magicka.")
	ElseIf (option == DestructionPerksID[16])
		SetInfoText("Cast Master level Destruction spells for half magicka.")
	EndIf
	
	;Enchanting page
	If (option == EnchantingPerksID[0])
		SetInfoText("New enchantments are 20% stronger.")
	ElseIf (option == EnchantingPerksID[1])
		SetInfoText("New enchantments are 40% stronger.")
	ElseIf (option == EnchantingPerksID[2])
		SetInfoText("New enchantments are 60% stronger.")
	ElseIf (option == EnchantingPerksID[3])
		SetInfoText("New enchantments are 80% stronger.")
	ElseIf (option == EnchantingPerksID[4])
		SetInfoText("New enchantments are 100% stronger.")
	ElseIf (option == EnchantingPerksID[5])
		SetInfoText("Soul gems provide extra magicka for recharging.")
	ElseIf (option == EnchantingPerksID[6])
		SetInfoText("Fire enchantments on weapons and armor are 25% stronger.")
	ElseIf (option == EnchantingPerksID[7])
		SetInfoText("Frost enchantments on weapons and armor are 25% stronger.")
	ElseIf (option == EnchantingPerksID[8])
		SetInfoText("Death blows to creatures, but not people, trap 5% of the victim's soul, recharging the weapon.")
	ElseIf (option == EnchantingPerksID[9])
		SetInfoText("Skill enchantments on armor are 25% stronger.")
	ElseIf (option == EnchantingPerksID[10])
		SetInfoText("Shock enchantments on weapons and armor are 25% stronger.")
	ElseIf (option == EnchantingPerksID[11])
		SetInfoText("Health, magicka, and stamina enchantments on armor are 25% stronger.")
	ElseIf (option == EnchantingPerksID[12])
		SetInfoText("Can put two enchantments on the same item.")
	EndIf
	
	;Heavy Armor page
	If (option == HeavyArmorPerksID[0])
		SetInfoText("Increases armor rating for Heavy Armor by 20%.")
	ElseIf (option == HeavyArmorPerksID[1])
		SetInfoText("Increases armor rating for Heavy Armor by 40%.")
	ElseIf (option == HeavyArmorPerksID[2])
		SetInfoText("Increases armor rating for Heavy Armor by 60%.")
	ElseIf (option == HeavyArmorPerksID[3])
		SetInfoText("Increases armor rating for Heavy Armor by 80%.")
	ElseIf (option == HeavyArmorPerksID[4])
		SetInfoText("Increases armor rating for Heavy Armor by 100%.")
	ElseIf (option == HeavyArmorPerksID[5])
		SetInfoText("Unarmed attacks with Heavy Armor gauntlets do their armor rating in extra damage.")
	ElseIf (option == HeavyArmorPerksID[6])
		SetInfoText("25% Armor bonus if wearing all Heavy Armor: head, chest, hands, feet.")
	ElseIf (option == HeavyArmorPerksID[7])
		SetInfoText("Half damage from falling if wearing all Heavy Armor: head, chest, hands, feet.")
	ElseIf (option == HeavyArmorPerksID[8])
		SetInfoText("50% less stagger when wearing only Heavy Armor.")
	ElseIf (option == HeavyArmorPerksID[9])
		SetInfoText("Heavy Armor weighs nothing and doesn't slow you down when worn.")
	ElseIf (option == HeavyArmorPerksID[10])
		SetInfoText("Additional 25% Armor bonus if wearing a matched set of Heavy Armor.")
	ElseIf (option == HeavyArmorPerksID[11])
		SetInfoText("10% chance to reflect melee damage back to the enemy while wearing all Heavy Armor: head, chest, hands, feet.")
	EndIf
	
	;Illusion page
	If (option == IllusionPerksID[0])
		SetInfoText("Cast Novice level Illusion spells for half magicka.")
	ElseIf (option == IllusionPerksID[1])
		SetInfoText("Illusion spells now work on higher level animals.")
	ElseIf (option == IllusionPerksID[2])
		SetInfoText("Dual casting an Illusion spell overcharges the effects into an even more powerful version.")
	ElseIf (option == IllusionPerksID[3])
		SetInfoText("Cast Apprentice level Illusion spells for half magicka.")
	ElseIf (option == IllusionPerksID[4])
		SetInfoText("Calm spells now work on higher level opponents. Cumulative with Kindred Mage and Animage.")
	ElseIf (option == IllusionPerksID[5])
		SetInfoText("All Illusion spells work on higher level people.")
	ElseIf (option == IllusionPerksID[6])
		SetInfoText("Cast Adept level Illusion spells for half magicka.")
	ElseIf (option == IllusionPerksID[7])
		SetInfoText("Fear spells work on higher level opponents. Cumulative with Kindred Mage and Animage.")
	ElseIf (option == IllusionPerksID[8])
		SetInfoText("All spells you cast from any school of magic are silent to others.")
	ElseIf (option == IllusionPerksID[9])
		SetInfoText("Frenzy spells work on higher level opponents. Cumulative with Kindred Mage and Animage.")
	ElseIf (option == IllusionPerksID[10])
		SetInfoText("Cast Expert level Illusion spells for half magicka.")
	ElseIf (option == IllusionPerksID[11])
		SetInfoText("Illusion spells work on undead, daedra and automatons.")
	ElseIf (option == IllusionPerksID[12])
		SetInfoText("Cast Master level Illusion spells for half magicka.")
	EndIf
	
	;Light Armor page
	If (option == LightArmorPerksID[0])
		SetInfoText("Increase armor rating for Light armor by 20%.")
	ElseIf (option == LightArmorPerksID[1])
		SetInfoText("Increase armor rating for Light armor by 40%.")
	ElseIf (option == LightArmorPerksID[2])
		SetInfoText("Increase armor rating for Light armor by 60%.")
	ElseIf (option == LightArmorPerksID[3])
		SetInfoText("Increase armor rating for Light armor by 80%.")
	ElseIf (option == LightArmorPerksID[4])
		SetInfoText("Increase armor rating for Light armor by 100%.")
	ElseIf (option == LightArmorPerksID[5])
		SetInfoText("25% Armor bonus if wearing all Light Armor: head, chest, hands, feet.")
	ElseIf (option == LightArmorPerksID[6])
		SetInfoText("Light Armor weighs nothing and doesn't slow you down when worn.")
	ElseIf (option == LightArmorPerksID[7])
		SetInfoText("Stamina regenerates 50% faster in all Light Armor: head, chest, hands, feet.")
	ElseIf (option == LightArmorPerksID[8])
		SetInfoText("Additional 25% Armor bonus if wearing a matched set of Light Armor.")
	ElseIf (option == LightArmorPerksID[9])
		SetInfoText("10% chance of avoiding all damage from a melee attack while wearing all Light Armor: head, chest, hands, feet.")
	EndIf
	
	;Lockpicking page
	If (option == LockpickingPerksID[0])
		SetInfoText("Novice locks are much easier to pick.")
	ElseIf (option == LockpickingPerksID[1])
		SetInfoText("Apprentice locks are much easier to pick.")
	ElseIf (option == LockpickingPerksID[2])
		SetInfoText("Able to pick locks without being noticed.")
	ElseIf (option == LockpickingPerksID[3])
		SetInfoText("Adept locks are much easier to pick.")
	ElseIf (option == LockpickingPerksID[4])
		SetInfoText("Automatically gives you a copy of a picked lock's key if it has one.")
	ElseIf (option == LockpickingPerksID[5])
		SetInfoText("Find more gold in chests.")
	ElseIf (option == LockpickingPerksID[6])
		SetInfoText("50% greater chance of finding special treasure.")
	ElseIf (option == LockpickingPerksID[7])
		SetInfoText("Expert locks are much easier to pick.")
	ElseIf (option == LockpickingPerksID[8])
		SetInfoText("Pick starts close to the lock opening position.")
	ElseIf (option == LockpickingPerksID[9])
		SetInfoText("Master locks are much easier to pick.")
	ElseIf (option == LockpickingPerksID[10])
		SetInfoText("Lockpicks never break.")
	EndIf
	
	;One Handed page
	If (option == OneHandedPerksID[0])
		SetInfoText("One-Handed weapons do 20% more damage.")
	ElseIf (option == OneHandedPerksID[1])
		SetInfoText("One-Handed weapons do 40% more damage.")
	ElseIf (option == OneHandedPerksID[2])
		SetInfoText("One-Handed weapons do 60% more damage.")
	ElseIf (option == OneHandedPerksID[3])
		SetInfoText("One-Handed weapons do 80% more damage.")
	ElseIf (option == OneHandedPerksID[4])
		SetInfoText("One-Handed weapons do twice as much damage.")
	ElseIf (option == OneHandedPerksID[5])
		SetInfoText("Power attacks with one-handed weapons cost 25% less stamina.")
	ElseIf (option == OneHandedPerksID[6])
		SetInfoText("Attacks with swords have a 10% chance of doing critical damage.")
	ElseIf (option == OneHandedPerksID[7])
		SetInfoText("Attacks with swords have a 15% chance of doing more critical damage.")
	ElseIf (option == OneHandedPerksID[8])
		SetInfoText("Attacks with swords have a 15% chance of doing more critical damage.")
	ElseIf (option == OneHandedPerksID[9])
		SetInfoText("Attacks with maces ignore 25% of armor.")
	ElseIf (option == OneHandedPerksID[10])
		SetInfoText("Attacks with maces ignore 50% of armor.")
	ElseIf (option == OneHandedPerksID[11])
		SetInfoText("Attacks with maces ignore 75% of armor.")
	ElseIf (option == OneHandedPerksID[12])
		SetInfoText("Dual wielding attacks are 20% faster.")
	ElseIf (option == OneHandedPerksID[13])
		SetInfoText("Dual wielding attacks are 35% faster.")
	ElseIf (option == OneHandedPerksID[14])
		SetInfoText("Attacks with war axes cause extra bleeding damage.")
	ElseIf (option == OneHandedPerksID[15])
		SetInfoText("Attacks with war axes cause more bleeding damage.")
	ElseIf (option == OneHandedPerksID[16])
		SetInfoText("Attacks with war axes cause even more bleeding damage.")
	ElseIf (option == OneHandedPerksID[17])
		SetInfoText("Can do a one-handed power attack while sprinting that does double critical damage.")
	ElseIf (option == OneHandedPerksID[18])
		SetInfoText("Standing power attacks do 25% bonus damage with a chance to decapitate your enemies.")
	ElseIf (option == OneHandedPerksID[19])
		SetInfoText("Dual wielding power attacks do 50% bonus damage.")
	ElseIf (option == OneHandedPerksID[20])
		SetInfoText("Backwards power attack has a 25% chance to paralyze the target.")
	EndIf
	
	;Pickpocket page
	If (option == PickpocketPerksID[0])
		SetInfoText("Pickpocketing bonus of 20%. Item weight and value reduce pickpocketing odds.")
	ElseIf (option == PickpocketPerksID[1])
		SetInfoText("Pickpocketing bonus of 40%. Item weight and value reduce pickpocketing odds.")
	ElseIf (option == PickpocketPerksID[2])
		SetInfoText("Pickpocketing bonus of 60%. Item weight and value reduce pickpocketing odds.")
	ElseIf (option == PickpocketPerksID[3])
		SetInfoText("Pickpocketing bonus of 80%. Item weight and value reduce pickpocketing odds.")
	ElseIf (option == PickpocketPerksID[4])
		SetInfoText("Pickpocketing bonus of 100%. Item weight and value reduce pickpocketing odds.")
	ElseIf (option == PickpocketPerksID[5])
		SetInfoText("+25% chance to pickpocket if the target is asleep.")
	ElseIf (option == PickpocketPerksID[6])
		SetInfoText("Pickpocketing gold is 50% easier.")
	ElseIf (option == PickpocketPerksID[7])
		SetInfoText("Silently harm enemies by placing poisons in their pockets.")
	ElseIf (option == PickpocketPerksID[8])
		SetInfoText("Carrying capacity is increased by 100.")
	ElseIf (option == PickpocketPerksID[9])
		SetInfoText("Pickpocketing keys almost always works.")
	ElseIf (option == PickpocketPerksID[10])
		SetInfoText("Can pickpocket equipped weapons.")
	ElseIf (option == PickpocketPerksID[11])
		SetInfoText("Can pickpocket equipped items.")
	EndIf
	
	;Restoration page
	If (option == RestorationPerksID[0])
		SetInfoText("Cast Novice level Restoration spells for half magicka.")
	ElseIf (option == RestorationPerksID[1])
		SetInfoText("Healing spells cure 50% more.")
	ElseIf (option == RestorationPerksID[2])
		SetInfoText("Dual casting a Restoration spell overcharges the effects into an even more powerful version. ")
	ElseIf (option == RestorationPerksID[3])
		SetInfoText("Cast Apprentice level Restoration spells for half magicka.")
	ElseIf (option == RestorationPerksID[4])
		SetInfoText("Magicka regenerates 25% faster.")
	ElseIf (option == RestorationPerksID[5])
		SetInfoText("Magicka regenerates 50% faster.")
	ElseIf (option == RestorationPerksID[6])
		SetInfoText("Healing spells also restore Stamina.")
	ElseIf (option == RestorationPerksID[7])
		SetInfoText("Cast Adept level Restoration spells for half magicka.")
	ElseIf (option == RestorationPerksID[8])
		SetInfoText("Wards recharge your magicka when hit with spells.")
	ElseIf (option == RestorationPerksID[9])
		SetInfoText("All spells are more effective against undead.")
	ElseIf (option == RestorationPerksID[10])
		SetInfoText("Cast Expert level Restoration spells for half magicka.")
	ElseIf (option == RestorationPerksID[11])
		SetInfoText("Once a day, heals 250 points automatically if you fall below 10% health.")
	ElseIf (option == RestorationPerksID[12])
		SetInfoText("Cast Master level Restoration spells for half magicka.")
	EndIf
	
	;Smithing page
	If (option == SmithingPerksID[0])
		SetInfoText("Can create Steel armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[1])
		SetInfoText("Can create Dwarven armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[2])
		SetInfoText("Can create Elven armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[3])
		SetInfoText("Can create Scaled and Plate armor at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[4])
		SetInfoText("Can create Orcish armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[5])
		SetInfoText("You can improve magical weapons and armor.")
	ElseIf (option == SmithingPerksID[6])
		SetInfoText("Can create Glass armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[7])
		SetInfoText("Can create Ebony armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[8])
		SetInfoText("Can create Daedric armor and weapons at forges, and improve them twice as much.")
	ElseIf (option == SmithingPerksID[9])
		SetInfoText("Can create Dragon armor at forges, and improve them twice as much.")
	EndIf
	
	;Sneak page
	If (option == SneakPerksID[0])
		SetInfoText("You are 20% harder to detect when sneaking.")
	ElseIf (option == SneakPerksID[1])
		SetInfoText("You are 25% harder to detect when sneaking.")
	ElseIf (option == SneakPerksID[2])
		SetInfoText("You are 30% harder to detect when sneaking.")
	ElseIf (option == SneakPerksID[3])
		SetInfoText("You are 35% harder to detect when sneaking.")
	ElseIf (option == SneakPerksID[4])
		SetInfoText("You are 40% harder to detect when sneaking.")
	ElseIf (option == SneakPerksID[5])
		SetInfoText("Sneak attacks with one-handed weapons now do six times damage.")
	ElseIf (option == SneakPerksID[6])
		SetInfoText("Wearing armor makes half as much noise when you move.")
	ElseIf (option == SneakPerksID[7])
		SetInfoText("Sneak attacks with bows now do three times damage.")
	ElseIf (option == SneakPerksID[8])
		SetInfoText("You won't trigger pressure plates.")
	ElseIf (option == SneakPerksID[9])
		SetInfoText("Sneak attacks with daggers now do a total of fifteen times normal damage.")
	ElseIf (option == SneakPerksID[10])
		SetInfoText("Sprinting while sneaking executes a silent forward roll.")
	ElseIf (option == SneakPerksID[11])
		SetInfoText("Running does not increase your detectability.")
	ElseIf (option == SneakPerksID[12])
		SetInfoText("Crouching stops combat for a moment and forces distant opponents to search for a target.")
	EndIf
	
	;Speech page
	If (option == SpeechPerksID[0])
		SetInfoText("Buying and selling prices are 10% better.")
	ElseIf (option == SpeechPerksID[1])
		SetInfoText("Buying and selling prices are 15% better.")
	ElseIf (option == SpeechPerksID[2])
		SetInfoText("Buying and selling prices are 20% better.")
	ElseIf (option == SpeechPerksID[3])
		SetInfoText("Buying and selling prices are 25% better.")
	ElseIf (option == SpeechPerksID[4])
		SetInfoText("Buying and selling prices are 30% better.")
	ElseIf (option == SpeechPerksID[5])
		SetInfoText("10% better prices with the opposite sex.")
	ElseIf (option == SpeechPerksID[6])
		SetInfoText("Can bribe guards to ignore crimes.")
	ElseIf (option == SpeechPerksID[7])
		SetInfoText("Can sell any type of item to any kind of merchant.")
	ElseIf (option == SpeechPerksID[8])
		SetInfoText("Persuasion attempts are 30% easier.")
	ElseIf (option == SpeechPerksID[9])
		SetInfoText("Intimidation is twice as likely to be successful.")
	ElseIf (option == SpeechPerksID[10])
		SetInfoText("Can invest 500 gold with a shopkeeper to increase his available gold permanently.")
	ElseIf (option == SpeechPerksID[11])
		SetInfoText("Can barter stolen goods with any merchant you have invested in.")
	ElseIf (option == SpeechPerksID[12])
		SetInfoText("Every merchant in the world gains 1000 gold for bartering.")
	EndIf
	
	;Two Handed page
	If (option == TwoHandedPerksID[0])
		SetInfoText("Two-Handed weapons do 20% more damage.")
	ElseIf (option == TwoHandedPerksID[1])
		SetInfoText("Two-Handed weapons do 40% more damage.")
	ElseIf (option == TwoHandedPerksID[2])
		SetInfoText("Two-Handed weapons do 60% more damage.")
	ElseIf (option == TwoHandedPerksID[3])
		SetInfoText("Two-Handed weapons do 80% more damage.")
	ElseIf (option == TwoHandedPerksID[4])
		SetInfoText("Two-Handed weapons do twice as much damage.")
	ElseIf (option == TwoHandedPerksID[5])
		SetInfoText("Power attacks with two-handed weapons cost 25% less stamina.")
	ElseIf (option == TwoHandedPerksID[6])
		SetInfoText("Attacks with greatswords have a 10% chance of doing critical damage.")
	ElseIf (option == TwoHandedPerksID[7])
		SetInfoText("Attacks with greatswords have a 15% chance of doing more critical damage.")
	ElseIf (option == TwoHandedPerksID[8])
		SetInfoText("Attacks with greatswords have a 20% chance of doing even more critical damage.")
	ElseIf (option == TwoHandedPerksID[9])
		SetInfoText("Attacks with battle axes cause extra bleeding damage.")
	ElseIf (option == TwoHandedPerksID[10])
		SetInfoText("Attacks with battle axes cause more bleeding damage.")
	ElseIf (option == TwoHandedPerksID[11])
		SetInfoText("Attacks with battle axes cause even more bleeding damage.")
	ElseIf (option == TwoHandedPerksID[12])
		SetInfoText("Attacks with warhammers ignore 25% of armor.")
	ElseIf (option == TwoHandedPerksID[13])
		SetInfoText("Attacks with warhammers ignore 50% of armor.")
	ElseIf (option == TwoHandedPerksID[14])
		SetInfoText("Attacks with warhammers ignore 75% of armor.")
	ElseIf (option == TwoHandedPerksID[15])
		SetInfoText("Standing power attacks do 25% bonus damage with a chance to decapitate your enemies.")
	ElseIf (option == TwoHandedPerksID[16])
		SetInfoText("Can do a two-handed power attack while sprinting that does double critical damage.")
	ElseIf (option == TwoHandedPerksID[17])
		SetInfoText("Sideways power attacks with two-handed weapons hit all targets in front of you.")
	ElseIf (option == TwoHandedPerksID[18])
		SetInfoText("Backwards power attack has a 25% chance to paralyze the target.")
	EndIf
	
EndEvent

Function SetRacialDefaults()
	;Sets slider default values based on player race
	Log("Player Race: " + PlayerRace as String)

	;FORMAT:
	;Default defaults
	;
	;Racial defaults
	If (PlayerRace == Altmer)
		Log("Setting defaults for Altmer.")
		HealthDef = 100.0
		StaminaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0
		
		MagickaDef = 150
	ElseIf (PlayerRace == Argonian)
		Log("Setting defaults for Argonian.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		PoisonResistDef = 0.0

		DiseaseResistDef = 50.0
		UnarmedDamageDef = 16.0
	ElseIf (PlayerRace == Bosmer)
		Log("Setting defaults for Bosmer.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		UnarmedDamageDef = 4.0
		
		PoisonResistDef = 50.0
		DiseaseResistDef = 50.0
	ElseIf (PlayerRace == Breton)
		Log("Setting defaults for Breton.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0

		MagicResistDef = 25.0
	ElseIf (PlayerRace == Dunmer)
		Log("Setting defaults for Dunmer.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0
		
		FireResistDef = 50.0
	ElseIf (PlayerRace == Imperial)
		Log("Setting defaults for Imperial.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0
		;no racial actor value changes
	ElseIf (PlayerRace == Khajiit)
		Log("Setting defaults for Khajiit.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0

		UnarmedDamageDef = 22
	ElseIf (PlayerRace == Nord)
		Log("Setting defaults for Nord.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0
		
		FrostResistDef = 50.0
	ElseIf (PlayerRace == Orc)
		Log("Setting defaults for Orc.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0
		;no racial actor value changes
	ElseIf (PlayerRace == Redguard)
		Log("Setting defaults for Redguard.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		UnarmedDamageDef = 4.0
		
		PoisonResistDef = 50.0
	Else ;in case of custom races
		Log("Setting defaults for non-standard race.")
		HealthDef = 100.0
		StaminaDef = 100.0
		MagickaDef = 100.0
		CarryWeightDef = 300.0
		HealRateDef = 0.7
		StaminaRateDef = 5.0
		MagickaRateDef = 3.0
		SpeedMultDef = 100.0
		ShoutRecoveryMultDef = 1.0
		CritChanceDef = 0.0
		WeaponSpeedMultDef = 0.0
		WeaponLeftSpeedMultDef = 0.0
		MagicResistDef = 0.0
		FrostResistDef = 0.0
		FireResistDef = 0.0
		ShockResistDef = 0.0
		DiseaseResistDef = 0.0
		PoisonResistDef = 0.0
		UnarmedDamageDef = 4.0
	EndIf
EndFunction

Function UpdatePerkStates(String PerkName)
	;updates perk state arrays to match currently selected perks
	Log("Updating states for " + PerkName + " perks")
	
	If (PerkName == "Alchemy")
		Int Counter = 0
		While (Counter < AlchemyPerksState.Length)
			If PlayerRef.HasPerk(AlchemyPerks[Counter])
				AlchemyPerksState[Counter] = True
			Else
				AlchemyPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Alteration")
		Int Counter = 0
		While (Counter < AlterationPerksState.Length)
			If PlayerRef.HasPerk(AlterationPerks[Counter])
				AlterationPerksState[Counter] = True
			Else
				AlterationPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Archery")
		Int Counter = 0
		While (Counter < ArcheryPerksState.Length)
			If PlayerRef.HasPerk(ArcheryPerks[Counter])
				ArcheryPerksState[Counter] = True
			Else
				ArcheryPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Block")
		Int Counter = 0
		While (Counter < BlockPerksState.Length)
			If PlayerRef.HasPerk(BlockPerks[Counter])
				BlockPerksState[Counter] = True
			Else
				BlockPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Conjuration")
		Int Counter = 0
		While (Counter < ConjurationPerksState.Length)
			If PlayerRef.HasPerk(ConjurationPerks[Counter])
				ConjurationPerksState[Counter] = True
			Else
				ConjurationPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Destruction")
		Int Counter = 0
		While (Counter < DestructionPerksState.Length)
			If PlayerRef.HasPerk(DestructionPerks[Counter])
				DestructionPerksState[Counter] = True
			Else
				DestructionPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Enchanting")
		Int Counter = 0
		While (Counter < EnchantingPerksState.Length)
			If PlayerRef.HasPerk(EnchantingPerks[Counter])
				EnchantingPerksState[Counter] = True
			Else
				EnchantingPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "HeavyArmor")
		Int Counter = 0
		While (Counter < HeavyArmorPerksState.Length)
			If PlayerRef.HasPerk(HeavyArmorPerks[Counter])
				HeavyArmorPerksState[Counter] = True
			Else
				HeavyArmorPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Illusion")
		Int Counter = 0
		While (Counter < IllusionPerksState.Length)
			If PlayerRef.HasPerk(IllusionPerks[Counter])
				IllusionPerksState[Counter] = True
			Else
				IllusionPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "LightArmor")
		Int Counter = 0
		While (Counter < LightArmorPerksState.Length)
			If PlayerRef.HasPerk(LightArmorPerks[Counter])
				LightArmorPerksState[Counter] = True
			Else
				LightArmorPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Lockpicking")
		Int Counter = 0
		While (Counter < LockpickingPerksState.Length)
			If PlayerRef.HasPerk(LockpickingPerks[Counter])
				LockpickingPerksState[Counter] = True
			Else
				LockpickingPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "OneHanded")
		Int Counter = 0
		While (Counter < OneHandedPerksState.Length)
			If PlayerRef.HasPerk(OneHandedPerks[Counter])
				OneHandedPerksState[Counter] = True
			Else
				OneHandedPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Pickpocket")
		Int Counter = 0
		While (Counter < PickpocketPerksState.Length)
			If PlayerRef.HasPerk(PickpocketPerks[Counter])
				PickpocketPerksState[Counter] = True
			Else
				PickpocketPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Restoration")
		Int Counter = 0
		While (Counter < RestorationPerksState.Length)
			If PlayerRef.HasPerk(RestorationPerks[Counter])
				RestorationPerksState[Counter] = True
			Else
				RestorationPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Smithing")
		Int Counter = 0
		While (Counter < SmithingPerksState.Length)
			If PlayerRef.HasPerk(SmithingPerks[Counter])
				SmithingPerksState[Counter] = True
			Else
				SmithingPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Sneak")
		Int Counter = 0
		While (Counter < SneakPerksState.Length)
			If PlayerRef.HasPerk(SneakPerks[Counter])
				SneakPerksState[Counter] = True
			Else
				SneakPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "Speech")
		Int Counter = 0
		While (Counter < SpeechPerksState.Length)
			If PlayerRef.HasPerk(SpeechPerks[Counter])
				SpeechPerksState[Counter] = True
			Else
				SpeechPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	ElseIf (PerkName == "TwoHanded")
		Int Counter = 0
		While (Counter < TwoHandedPerksState.Length)
			If PlayerRef.HasPerk(TwoHandedPerks[Counter])
				TwoHandedPerksState[Counter] = True
			Else
				TwoHandedPerksState[Counter] = False
			EndIf
			Counter += 1
		EndWhile
	Else
		Log("Bad perk name; could not update states", 2)
	EndIf
	
EndFunction

Function AddPerksFunc(Perk[] PerkList, Bool[] PerkTrack, String msg)
	;Adds all non-selected perks for a skill to the player
	;and tracks the perks added by this mod

	Log("Adding " + msg + " perks")

	Int Counter = 0
	While (counter < PerkList.Length)
		;If player does not have a perk, give it to them and track that it was added by this mod
		If !(PlayerRef.HasPerk(PerkList[Counter]))
			PlayerRef.AddPerk(PerkList[Counter])
			PerkTrack[Counter] = True
		EndIf
		Counter += 1
	EndWhile

	Log("Done adding " + msg + " perks")
	MBox("Completed adding " + msg + " perks.")

EndFunction

Function RemovePerksFunc(Perk[] PerkList, Bool[] PerkTrack, String msg)
	;Removes all or tracked perks from a skill

	Log("Removing " + msg + " perks")

	Int Counter = 0
	
	;If the tracking option is enabled only remove tracked skill perks
	If TrackState
		While (Counter < PerkList.Length)
			If (PerkTrack[Counter])
				PlayerRef.RemovePerk(PerkList[Counter])
			EndIf
			Counter += 1
		EndWhile
	Else ;If the tracking option is not enabled remove all skill perks
		While (Counter < PerkList.Length)
			If PlayerRef.HasPerk(PerkList[Counter])
				PlayerRef.RemovePerk(PerkList[Counter])
				If !(PerkTrack[Counter]) ;refund perk point if not a tracked perk
					Game.AddPerkPoints(1)
				EndIf
			EndIf
			Counter += 1
		EndWhile
	EndIf

	Log("Done removing " + msg + " perks")
	MBox("Completed removing " + msg + " perks.")

EndFunction

Function AddRemovePerkFunc(Perk[] PerkList, Bool[] PerkTrack, Bool[] PerkState, Int index)
	;Add or remove individual perks
	
	If !(PerkState[index]) ;if player does not have perk, add it and track it
		Log("Adding perk: " + PerkList[index] as String)
		PlayerRef.AddPerk(PerkList[index])
		PerkTrack[index] = True
	Else ;else player has perk, remove it and if NOT tracked refund a perk point OR untrack it
		PlayerRef.RemovePerk(PerkList[index])
		Log("Removing perk: " + PerkList[index] as String)
		If !(PerkTrack[index])
			Log("Refunding perk point")
			Game.AddPerkPoints(1)
		Else
			PerkTrack[index] = False
		EndIf
	EndIf
EndFunction

Function SaveConfig(String file)
	;Save config state to file
	;Booleans are stored as Integers. False:0, True:1
	
	Log("Saving state to /Data/SCP_Saves/" + file)
	MBox("Please wait while your config state is being saved.")
	
	;update perk states
	UpdatePerkStates("Alchemy")
	UpdatePerkStates("Alteration")
	UpdatePerkStates("Archery")
	UpdatePerkStates("Block")
	UpdatePerkStates("Conjuration")
	UpdatePerkStates("Destruction")
	UpdatePerkStates("Enchanting")
	UpdatePerkStates("HeavyArmor")
	UpdatePerkStates("Illusion")
	UpdatePerkStates("LightArmor")
	UpdatePerkStates("Lockpicking")
	UpdatePerkStates("OneHanded")
	UpdatePerkStates("Pickpocket")
	UpdatePerkStates("Restoration")
	UpdatePerkStates("Smithing")
	UpdatePerkStates("Sneak")
	UpdatePerkStates("Speech")
	UpdatePerkStates("TwoHanded")
	
	;perk state containers
	Int jAlchemyState = jArray.objectWithBooleans(AlchemyPerksState)
	Int jAlterationState = jArray.objectWithBooleans(AlterationPerksState)
	Int jArcheryState = jArray.objectWithBooleans(ArcheryPerksState)
	Int jBlockState = jArray.objectWithBooleans(BlockPerksState)
	Int jConjurationState = jArray.objectWithBooleans(ConjurationPerksState)
	Int jDestructionState = jArray.objectWithBooleans(DestructionPerksState)
	Int jEnchantingState = jArray.objectWithBooleans(EnchantingPerksState)
	Int jHeavyArmorState = jArray.objectWithBooleans(HeavyArmorPerksState)
	Int jIllusionState = jArray.objectWithBooleans(IllusionPerksState)
	Int jLightArmorState = jArray.objectWithBooleans(LightArmorPerksState)
	Int jLockpickingState = jArray.objectWithBooleans(LockpickingPerksState)
	Int jOneHandedState = jArray.objectWithBooleans(OneHandedPerksState)
	Int jPickpocketState = jArray.objectWithBooleans(PickpocketPerksState)
	Int jRestorationState = jArray.objectWithBooleans(RestorationPerksState)
	Int jSmithingState = jArray.objectWithBooleans(SmithingPerksState)
	Int jSneakState = jArray.objectWithBooleans(SneakPerksState)
	Int jSpeechState = jArray.objectWithBooleans(SpeechPerksState)
	Int jTwoHandedState = jArray.objectWithBooleans(TwoHandedPerksState)
	;stats container
	Int jStatsState = jMap.object()
	;container for containers. Finally, multi-dimensional arrays!
	Int jSavingBox = jMap.object()

	;Store stat states
	jMap.setFlt(jStatsState, "Health", HealthState)
	jMap.setFlt(jStatsState, "Stamina", StaminaState)
	jMap.setFlt(jStatsState, "Magicka", MagickaState)
	jMap.setFlt(jStatsState, "Health Regen", HealRateState)
	jMap.setFlt(jStatsState, "Stamina Regen", StaminaRateState)
	jMap.setFlt(jStatsState, "Magicka Regen", MagickaRateState)
	jMap.setFlt(jStatsState, "Speed Mult", SpeedMultState)
	jMap.setFlt(jStatsState, "Weapon Speed Mult", WeaponSpeedMultState)
	jMap.setFlt(jStatsState, "Weapon Left Speed Mult", WeaponLeftSpeedMultState)
	jMap.setFlt(jStatsState, "Magic Resist", MagicResistState)
	jMap.setFlt(jStatsState, "Fire Resist", FireResistState)
	jMap.setFlt(jStatsState, "Frost Resist", FrostResistState)
	jMap.setFlt(jStatsState, "Shock Resist", ShockResistState)
	jMap.setFlt(jStatsState, "Disease Resist", DiseaseResistState)
	jMap.setFlt(jStatsState, "Poison Resist", PoisonResistState)
	jMap.setFlt(jStatsState, "Shout Recovery Mult", ShoutRecoveryMultState)
	jMap.setFlt(jStatsState, "Crit Chance", CritChanceState)
	jMap.setFlt(jStatsState, "Carry Weight", CarryWeightState)
	jMap.setFlt(jStatsState, "Unarmed Damage", UnarmedDamageState)
	jMap.setInt(jStatsState, "Perk Tracking", TrackState as Int)
	
	;Package up containers to write out
	jMap.setObj(jSavingBox, "Stats", jStatsState)
	jMap.setObj(jSavingBox, "Alchemy", jAlchemyState)
	jMap.setObj(jSavingBox, "Alteration", jAlterationState)
	jMap.setObj(jSavingBox, "Archery", jArcheryState)
	jMap.setObj(jSavingBox, "Block", jBlockState)
	jMap.setObj(jSavingBox, "Conjuration", jConjurationState)
	jMap.setObj(jSavingBox, "Destruction", jDestructionState)
	jMap.setObj(jSavingBox, "Enchanting", jEnchantingState)
	jMap.setObj(jSavingBox, "HeavyArmor", jHeavyArmorState)
	jMap.setObj(jSavingBox, "Illusion", jIllusionState)
	jMap.setObj(jSavingBox, "LightArmor", jLightArmorState)
	jMap.setObj(jSavingBox, "Lockpicking", jLockpickingState)
	jMap.setObj(jSavingBox, "OneHanded", jOneHandedState)
	jMap.setObj(jSavingBox, "Pickpocket", jPickpocketState)
	jMap.setObj(jSavingBox, "Restoration", jRestorationState)
	jMap.setObj(jSavingBox, "Sneak", jSneakState)
	jMap.setObj(jSavingBox, "Speech", jSpeechState)
	jMap.setObj(jSavingBox, "TwoHanded", jTwoHandedState)
	jMap.setObj(jSavingBox, "Smithing", jSmithingState)
	
	jValue.writeTofile(jSavingBox, "Data/SCP_Saves/" + file)
	
	MBox("Save Complete")

EndFunction

Function LoadConfig(String file)
	;Load config settings from file and apply them
	;Booleans are stored as Integers. False:0, True:1
	Log("Loading state from " + file)
	MBox("Please wait while your config is loaded and settings applied.")
	
	;Read save from file to top level container
	Int jLoadBox = jValue.readFromFile("Data/SCP_Saves/" + file)
	Int jPerkBox ;container for shuffling arrays from top level container to function calls
	
	;Set perk tracking
	TrackState = jValue.solveInt(jLoadBox, ".Stats.Perk Tracking") as Bool
	
	;Set stats
	PlayerRef.SetActorValue("health", jValue.SolveFlt(jLoadBox, ".Stats.Health"))
	PlayerRef.SetActorValue("stamina", jValue.SolveFlt(jLoadBox, ".Stats.Stamina"))
	PlayerRef.SetActorValue("magicka", jValue.SolveFlt(jLoadBox, ".Stats.Magicka"))
	PlayerRef.ForceActorValue("healrate", jValue.SolveFlt(jLoadBox, ".Stats.Health Regen"))
	PlayerRef.ForceActorValue("staminarate", jValue.SolveFlt(jLoadBox, ".Stats.Stamina Regen"))
	PlayerRef.ForceActorValue("magickarate", jValue.SolveFlt(jLoadBox, ".Stats.Magicka Regen"))
	PlayerRef.SetActorValue("magicresist", jValue.SolveFlt(jLoadBox, ".Stats.Magic Resist"))
	PlayerRef.SetActorValue("fireresist", jValue.SolveFlt(jLoadBox, ".Stats.Fire Resist"))
	PlayerRef.SetActorValue("frostresist", jValue.SolveFlt(jLoadBox, ".Stats.Frost resist"))
	PlayerRef.SetActorValue("electricresist", jValue.SolveFlt(jLoadBox, ".Stats.Shock Resist"))
	PlayerRef.SetActorValue("poisonresist", jValue.SolveFlt(jLoadBox, ".Stats.Poison Resist"))
	PlayerRef.SetActorValue("diseaseresist", jValue.SolveFlt(jLoadBox, ".Stats.Disease Resist"))
	PlayerRef.SetActorValue("speedmult", jValue.SolveFlt(jLoadBox, ".Stats.Speed Mult"))
	PlayerRef.SetActorValue("weaponspeedmult", jValue.SolveFlt(jLoadBox, ".Stats.Weapon Speed Mult"))
	PlayerRef.SetActorValue("leftweaponspeedmult", jValue.SolveFlt(jLoadBox, ".Stats.Weapon Left Speed Mult"))
	PlayerRef.SetActorValue("shoutrecoverymult", jValue.SolveFlt(jLoadBox, ".Stats.Shout Recovery Mult"))
	PlayerRef.SetActorValue("unarmeddamage", jValue.SolveFlt(jLoadBox, ".Stats.Unarmed Damage"))
	PlayerRef.ForceActorValue("carryweight", jValue.SolveFlt(jLoadBox, ".Stats.Carry Weight"))
	PlayerRef.SetActorValue("critchance", jValue.SolveFlt(jLoadBox, ".Stats.Crit Chance"))
	
	jPerkBox = jMap.getObj(jLoadBox, "Alchemy")
	SetPerks(AlchemyPerks, AlchemyPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Alteration")
	SetPerks(AlterationPerks, AlterationPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Archery")
	SetPerks(ArcheryPerks, ArcheryPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Block")
	SetPerks(BlockPerks, BlockPerksTrack, jPerkBox)
	jPerkBox = jMap.getObj(jLoadBox, "Conjuration")
	SetPerks(ConjurationPerks, ConjurationPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Destruction")
	SetPerks(DestructionPerks, DestructionPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Enchanting")
	SetPerks(EnchantingPerks, EnchantingPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "HeavyArmor")
	SetPerks(HeavyArmorPerks, HeavyArmorPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Illusion")
	SetPerks(IllusionPerks, IllusionPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "LightArmor")
	SetPerks(LightArmorPerks, LightArmorPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Lockpicking")
	SetPerks(LockpickingPerks, LockpickingPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "OneHanded")
	SetPerks(OneHandedPerks, OneHandedPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Pickpocket")
	SetPerks(PickpocketPerks, PickpocketPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Restoration")
	SetPerks(RestorationPerks, RestorationPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Smithing")
	SetPerks(SmithingPerks, SmithingPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Sneak")
	SetPerks(SneakPerks, SneakPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "Speech")
	SetPerks(SpeechPerks, SpeechPerksTrack, jPerkBox)
	
	jPerkBox = jMap.getObj(jLoadBox, "TwoHanded")
	SetPerks(TwoHandedPerks, TwoHandedPerksTrack, jPerkBox)
	
	MBox("Loading Complete")
EndFunction

Function SetPerks(Perk[] PerkList, Bool[] PerkTrack, Int jPerkState)
	;LoadConfig helper function
	;Add/Remove perks to conform to jPerkState
	;Booleans stored as Integers. False:0, True:1
	
	Int Counter = 0
	While (Counter < PerkList.Length)
		If (jArray.getInt(jPerkState, Counter) == 1) ;If state is 'True'
			If !(PlayerRef.HasPerk(PerkList[Counter])) ;and player doesn't have the perk, add it and track it
				PlayerRef.AddPerk(PerkList[Counter])
				PerkTrack[Counter] = True
			Else ;if the player does have the perk, make sure it's not being tracked.
				PerkTrack[Counter] = False
			EndIf
		Else
			If PlayerRef.HasPerk(PerkList[Counter]) ;if player has the perk, remove it
				PlayerRef.RemovePerk(PerkList[Counter])
				If !(PerkTrack[Counter]) ;if perk is not tracked, refund perk point
					Log("Refunding perk point")
					Game.AddPerkPoints(1)
				EndIf
			EndIf
			PerkTrack[Counter] = False ;make sure perks the player doesn't have are not being tracked
		EndIf
		Counter += 1
	EndWhile
	
EndFunction

;GENERIC HELPER FUNCTIONS TO MAKE MY LIFE EASIER
;Logging helper
Function Log(String msg, int level = 0)
	String header = "[SCP]"
	If (level >= 2)
		header = header + "[ERR]: " + msg
	ElseIf (level == 1)
		header = header + "[WARN]: " + msg
	Else
		header = header + ": " + msg
	EndIf
	Debug.Trace(header)
EndFunction

;Notification helper
Function Notify(String msg)
	Debug.Notification(msg)
EndFunction

;Message box helper
Function MBox(String msg)
	Debug.MessageBox(msg)
EndFunction
